#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <alloc.h>

const double PI=M_PI, GAMMA=0.577215664901532860607;

int maxOrdC(int,double),maxOrdS(int,double);

double 	JBesCyl(int,double),			factorial(int),
			YBesCyl(int,double),			JBesSph(int,double),
			YBesSph(int,double),       IBesCyl(int,double),
			KBesCyl(int,double),			k0(double),
			k0_large(double),          GammaFnc(double),
			psum(int,double),				IncGamma(double,double),
			SmlGamma(double,double),	Digamma(double),
			PolyGam(int,double),			polytop(int,double),
			polydown(int,double),		ExpInt(int,double),
			e1_pwr(double),				en_cnf(int,double),
			Ei(double),						Chb1Poly(int,double),
			Chb2Poly(int,double),		GegPoly(double,int,double),
			HerPoly(int,double),			JacPoly(double,double,int,double),
			LagPoly(double,int,double),LegPoly(int,double),
			AscLeg(int,int,double),		Error(double),
			erfpwr(double),				erfcnf(double),
			Nprob(double),					p_pwr(double),
			q_cnf(double),					ChiSqrQ(double,int),
			BernNum(int),					BernPoly(int,double),
			EulerNum(int),					EulerPoly(int,double),
			bicoef(int,int),				power(double,int),
			Zeta(int),                 Adet(double*,int),
			find_det(double*,int);

void send_err_msg(int,int),move_largest(double*,int,int,double&);

const int   IDNGTEQ0    =  0,    IDXGT0      =  1,    IDXNOTEQ0   =  2,
				IDABSXLT1   =  3,    IDXGT0LT50  =  4,    IDAGTMIN1   =  5,
				IDLGTEQ0    =  6,    IDM0TOL     =  7,    IDNXGTEQ0   =  8,
				IDNGT1X0    =  9,    IDAXNLT0    =  10,   IDAXNEQ0    =  11,
				IDAGT0XNLT0 =  12,   IDXSQGT0    =  13,   IDNUGTEQ1   =  14,
				IDNGT1      =  15,	IDALLOC		=	16;

char error_msg[][30]={
	"N must be >= 0.",                  "X must be > 0.",
	"X must not = 0.",                  "|X| must be <= 1.",
	"X must be >0, <=50.",              "A must be > -1.",
	"L must be >= 0.",                  "M must be >= 0 and <= L.",
	"N & X must be >= 0.",              "N must be >1 when X=0.",
	"A & X must be >= 0.",              "X must be >0 when A=0.",
	"A must be > 0 and X >= 0.",        "Xsq must be > 0.",
	"Nu must be >= 1.",                 "N must be > 1.",
	"Bad alloc. for col in array."
};

const int	IDCBF1	=	0,		IDCBF2	=	1,		IDSBF1	=	2,
				IDSBF2	=	3,    IDMBI		=	4,		IDMBK		=	5,
				IDGF		=	6,		IDIG		=	7,    IDSG		=	8,
				IDDIG		=	9,		IDPOG		=	10,	IDZETA	=  11,
				IDEXI		=	12,	IDEI		=	13,	IDCP1		=	14,
				IDCP2		=	15,	IDGP		=	16,	IDHP		=	17,
				IDJP		=	18,	IDGLP		=	19,	IDLP		=	20,
				IDALF		=	21,   IDERR    =  22,	IDNPR    =  23,
				IDXSQQ	=	24,	IDBN		=	25,	IDBP		=	26,
				IDEN		=	27,	IDEP		=	28,	IDADET	=	29;

char funcname[][15] = {	"JBesCyl",		"YBesCyl",		"JBesSph",
								"YBesSph",     "IBesCyl",		"KBesCyl",
								"GammaFnc",		"IncGamma",		"SmlGamma",
								"Digamma",		"PolyGam",		"Zeta",
								"ExpInt",		"Ei",				"Chb1Poly",
								"Chb2Poly",		"GegPoly",		"HerPoly",
								"JacPoly",		"LagPoly",		"LegPoly",
								"AscLeg",		"Error",			"Nprob",
								"ChiSqrQ",		"BernNum",		"BernPoly",
								"EulerNum",		"EulerPoly",	"Adet"
};
