/* demo1.c
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

#include <stdio.h>
#include <std.h>
#include <pc.h>

#include "f:\gcc\proj\spr\src\jlib.h"

/* This demo shows how to load and display a .pcx file,  how to fade the
** screen in and out using the library functions, and how to use an offscreen
** buffer.
*/

int main(void)
{
 image *pcx_pic;
 buffer_rec *offscreen;
 unsigned char *pal;
 char *filename = "demo1.pcx";

 /* initialise screen sized buffer */
 offscreen = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);

 /* check that initialisation was OK */
 if(offscreen == NULL){
    printf("ERROR:could not initialise buffer.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* load pcx */
 pcx_pic = image_load_pcx(filename);

 /* check that load was OK */
 if(pcx_pic == NULL){
    printf("ERROR:could not load image file.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* set pal to point to the images palette */
 pal = IMG_PALETTE(pcx_pic);

 /* set up the mode 13h screen */
 screen_set_video_mode();
 screen_blank_pal();

 /* copy the image to the offscreen buffer */
 buff_blit_img_to(offscreen,0,0,pcx_pic,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);

 /* blit the buffer to the screen and wait for a keypress */
 screen_blit_fs_buff(offscreen,0,0);
 getkey();

 /* fade in the palette and wait for a keypress */
 screen_fade_in_pal(pal,40);
 getkey();

 /* fade out the palette and wait for a keypress */
 screen_fade_out_pal(pal,40);
 getkey();

 screen_blank_pal();

 /* fade in the palette and wait for a keypress */
 screen_fade_in_pal(pal,80);
 getkey();

 /* fade out the palette and wait for a keypress */
 screen_fade_out_pal(pal,80);
 getkey();

 /* return to text mode and exit */
 screen_set_text_mode();
 return(0);
}
