/* demo2.c
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

/* this demo shows how to load a .pcx,  use an offscreen buffer and perform
** horizontal scrolling useing the library.
*/

#include <stdio.h>
#include <std.h>
#include <pc.h>
#include "f:\gcc\proj\spr\src\jlib.h"

int main(void)
{
 int i;
 image *pcx_pic;
 buffer_rec *offscreen;

 /* init buffer */
 offscreen = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);

 /* check that initialisation was OK */
 if(offscreen == NULL){
    printf("ERROR:could not initialise buffer.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* load pcx */
 pcx_pic = image_load_pcx("demo2.pcx");

 /* check that load was OK */
 if(pcx_pic == NULL){
    printf("ERROR:could not load image file.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* set mode and palette */
 screen_set_video_mode();
 screen_block_set_pal(IMG_PALETTE(pcx_pic));

 /* put image into offscreen buffer */
 buff_blit_img_to(offscreen,0,0,pcx_pic,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);


 /* do scrolling by moving through the offscreen buffer */
 do{
   for(i=0;i<50;i++){
       screen_blit_buff_toNC(0,0,offscreen,10,i,B_X_SIZE(offscreen),i+150);
   }

   for(i=50;i>0;i--){
       screen_blit_buff_toNC(0,0,offscreen,10,i,B_X_SIZE(offscreen),i+150);
   }

 }while(!kbhit());

 /* return to text mode and exit */
 screen_set_text_mode();
 return 0;
}
