/* demo3.c
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

#include <stdlib.h>
#include <stdio.h>
#include <pc.h>

#include "f:\gcc\proj\spr\src\jlib.h"

#define RANDOM(num) ((rand()*num)/RAND_MAX)

int main(void)
{
      int i=0;
      int count=0;
      double start_time, end_time;

      srand((int)time(NULL)|1);

/***************************/
/* test line drawing speed */
/***************************/
      screen_set_video_mode();

      start_time = clock();
      while(!kbhit()){
	    screen_draw_lineNC(RANDOM(SCREEN_WIDTH), RANDOM(SCREEN_HEIGHT),
	    RANDOM(SCREEN_WIDTH), RANDOM(SCREEN_HEIGHT), i = ++i % 255);
	    count++;
      }
      end_time = clock();

      getkey();
      screen_set_text_mode();

      printf("lines drawn: %d\n",count);
      printf("lines per second: %3.2f\n",(double)count/(double)((end_time-start_time)/1000000));

      getkey();


/****************************/
/* test point drawing speed */
/****************************/
      screen_set_video_mode();
      count = 0;

      start_time = clock();
      while(!kbhit()){
	 screen_draw_pointNC(RANDOM(SCREEN_WIDTH), RANDOM(SCREEN_HEIGHT),
	 i = ++i % 255);
	 count++;
      }
      end_time = clock();

      getkey();
      screen_set_text_mode();

      printf("points drawn: %d\n",count);
      printf("points per second: %3.2f\n",(double)count/(double)((end_time-start_time)/1000000));

      getkey();

/********************************/
/* test rectangle drawing speed */
/********************************/
      screen_set_video_mode();
      count = 0;

      start_time = clock();
      while(!kbhit()){
	 screen_draw_rectNC(RANDOM(SCREEN_WIDTH), RANDOM(SCREEN_HEIGHT),
			    RANDOM(SCREEN_WIDTH), RANDOM(SCREEN_HEIGHT),
			    i = ++i % 255);
	 count++;
      }
      end_time = clock();

      getkey();
      screen_set_text_mode();

      printf("rectangles drawn: %d\n",count);
      printf("rectangles per second: %3.2f\n",(double)count/(double)((end_time-start_time)/1000000));

/****************************/
/* test ellipse drawing speed */
/****************************/
      screen_set_video_mode();
      count = 0;

      start_time = clock();
      while(!kbhit()){
	 screen_draw_ellipseNC(RANDOM(SCREEN_WIDTH)/2+SCREEN_WIDTH/4,
	 RANDOM(SCREEN_HEIGHT)/2+SCREEN_HEIGHT/4, RANDOM(SCREEN_WIDTH)/4,
	 RANDOM(SCREEN_HEIGHT)/4,i = ++i % 255);
	 count++;
      }
      end_time = clock();

      getkey();
      screen_set_text_mode();

      printf("ellipses drawn: %d\n",count);
      printf("ellipses per second: %3.2f\n",(double)count/(double)((end_time-start_time)/1000000));

      getkey();

      return(0);
}
