/* demo4.c
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

#include <stdio.h>
#include <std.h>
#include <pc.h>
#include "f:\gcc\proj\spr\src\jlib.h"

#define COLOR 100

int main(void)
{
 int xpos,ypos,buttons;
 USHORT stx,sty,edx,edy;
 image *pcx_pic;
 buffer_rec *offscreen;

 if(!mouse_present()){
    printf("no mouse installed");
    exit(-1);
 }

 /* initialise screen sized buffer */
 offscreen = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);

 /* check that initialisation was OK */
 if(offscreen == NULL){
    printf("ERROR:could not initialise buffer.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* load pcx */
 pcx_pic = image_load_pcx("demo4.pcx");

 /* check that load was OK */
 if(pcx_pic == NULL){
    printf("ERROR:could not load image file.\n");
    printf("press any key to exit.\n");
    getkey();
    exit(0);
 }

 /* set up the mode 13h screen */
 screen_set_video_mode();
 screen_block_set_pal(IMG_PALETTE(pcx_pic));

 /* copy the image to the offscreen buffer */
 buff_blit_img_to(offscreen,0,0,pcx_pic,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);

 /* show buffer and turn on mouse pointer */
 screen_blit_fs_buff(offscreen,0,0);
 mouse_show_pointer();

 /* this loop draws lines from the position the mouse is at when the left  **
 ** buttons are pressed.                                                   */
 do{
    mouse_get_status(&xpos,&ypos,&buttons);
    if(LEFT_BUTTON_DOWN(buttons)){
       stx=MOUSE_X_TO_SCREEN(xpos);
       sty=MOUSE_Y_TO_SCREEN(ypos);
       do{
	 mouse_get_status(&xpos,&ypos,&buttons);
	 if(!LEFT_BUTTON_DOWN(buttons)){
	    edx=MOUSE_X_TO_SCREEN(xpos);
	    edy=MOUSE_Y_TO_SCREEN(ypos);
	    mouse_hide_pointer();
	    screen_draw_line(stx,sty,edx,edy,COLOR);
	    mouse_show_pointer();
	    break;
	 }
       }while(1);
    }
 }while(!kbhit());

 /* wait for a key press, hide the pointer, re-blit the screen & show pointer */
 getkey();
 mouse_hide_pointer();
 screen_blit_fs_buff(offscreen,0,0);


 /* this loop draws boxes from the position the mouse is at when the left  **
 ** buttons are pressed.                                                   */
 mouse_show_pointer();
 do{
    mouse_get_status(&xpos,&ypos,&buttons);
    if(LEFT_BUTTON_DOWN(buttons)){
       stx=MOUSE_X_TO_SCREEN(xpos);
       sty=MOUSE_Y_TO_SCREEN(ypos);
       do{
	 mouse_get_status(&xpos,&ypos,&buttons);
	 if(!LEFT_BUTTON_DOWN(buttons)){
	    edx=MOUSE_X_TO_SCREEN(xpos);
	    edy=MOUSE_Y_TO_SCREEN(ypos);
	    mouse_hide_pointer();
	    screen_draw_box(stx,sty,edx,edy,100);
	    mouse_show_pointer();
	    break;
	 }
       }while(1);
    }
 }while(!kbhit());

 /* set text mode and exit */
 screen_set_text_mode();
 return(1);
}
