#include <assert.h>
#include <pc.h>
/* change this line to point to wherever you are keeping maketrig */
#include "f:\gcc\proj\trig\maketrig.h"
#include "f:\gcc\proj\spr\src\jlib.h"

#ifndef NULL
 #define NULL 0L
#endif

#define NUM_STEPS 400
#define NUM_LETTERS 16

/* This demo shows some simple sprite stuff using the direct to screen
** functions.  Because the sprites are updated on screen,  you may see some
** flicker. Demo6 shows how to display sprites using offscreen buffers.
*/

int main(void)
{
 int j,radius;
 sprite_system *sdemo;
 buffer_rec *offscreen;
 image *pcx_pic;
 UBYTE *pal,i;
 int *jsin,*jcos;

 /* create sin/cos tables */
 jsin = create_sin_table(NUM_STEPS);
 jcos = create_cos_table(NUM_STEPS);

 offscreen = buff_init(320,200);
 assert(offscreen!=NULL);

 pcx_pic = image_load_pcx("demo5.pcx");
 assert(pcx_pic!=NULL);

 sdemo = sprite_init(16,16);
 assert(sdemo!=NULL);

 sprite_load("demo5.spr",sdemo);

 pal = IMG_PALETTE(pcx_pic);
 assert(pal!=NULL);

 screen_set_video_mode();
 screen_block_set_pal(pal);
 screen_put_pal(67,255,255,255); /* make the sprites white */

 /* copy image to buffer */
 buff_blit_img_to(offscreen,0,0,pcx_pic,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);

 screen_blit_fs_buff(offscreen,0,0);

 for(i=0;i<NUM_LETTERS;i++){
     sprite_set_an_frame(sdemo,i,i);
     sprite_turn_on(sdemo,i);
 }

 radius = 90;

 do{
       /* draw circular sprite path */
       for(j=0;j<NUM_STEPS;j++){


	   for(i=0;i<NUM_LETTERS;i++){
	       int angle;
	       angle = j + (i*(NUM_STEPS/NUM_LETTERS))+1;
	       angle = angle % NUM_STEPS;
	       sprite_set_xy(sdemo,i,220+FAST_OFFSET(angle,radius,jcos),160+
				     FAST_OFFSET(angle,radius,jsin));
	       screen_save_sprite(sdemo,i);
	       screen_draw_sprite(sdemo,i);
	   }

	   screen_wait_vsync(); /* this helps reduce flicker */

	   for(i=0;i<NUM_LETTERS;i++){
	       screen_rest_sprite(sdemo,i);
	   }
       }

 }while(!kbhit());


 getkey();

 screen_set_text_mode();
 return(1);
}

