/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/
#include <std.h>
#include "..\jlib.h"
#include "..\memcopy.h"

/*+------------------------------------------------------------------------+*/
/*|blit a portion of a buffer to another buffer without clipping           |*/
/*+------------------------------------------------------------------------+*/
#undef LIBDEBUG
#ifdef __DEBUG_buff_blit_buff_toNC
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

#ifndef _SWAP
#define _SWAP(a,b) a^=b;b^=a;a^=b
#endif

inline void buff_blit_buff_toNC(buffer_rec *dbuff, USHORT dbfx, USHORT dbfy,
		     buffer_rec *sbuff,USHORT sbx1, USHORT sby1,USHORT sbx2, USHORT sby2)
{
 int v_iterations;
 unsigned int h_len;

 UBYTE *src=B_BUFF_PTR(sbuff),*dest=B_BUFF_PTR(dbuff);
 USHORT sbuffx=B_X_SIZE(sbuff),dbuffx=B_X_SIZE(dbuff);

 LIBDEBUG(printf("\nEntering buff_blit_buff_toNC()\n\n"));

 /* sort coordinates if needed */
 if(sbx2<sbx1){
    _SWAP(sbx1,sbx2);
 }
 if(sby2<sby1){
    _SWAP(sby1,sby2);
 }

 src+=(sby1*sbuffx)+sbx1;
 dest+=(dbfy*dbuffx)+dbfx;

 v_iterations=(sby2-sby1); /* number of times to repeat horiz. blit */
 h_len=(sbx2-sbx1);  /* length of horizontal blit */

 switch(get_copy_method2((unsigned int)src,(unsigned int)dest,h_len)){

   case USE_SB:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sb(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_SW:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sw(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case INC_USE_SW:
	for(;v_iterations!=0;v_iterations--){
	    _copy_inc_sw(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_SW_INC:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sw_inc(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_INC_SW_INC:
	for(;v_iterations!=0;v_iterations--){
	    _copy_inc_sw_inc(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   default:
	LIBDEBUG(printf("\nUnknown value returned from get_copy_method()\n\n"));
	exit(0);
	break;
 }

 LIBDEBUG(printf("\nLeaving buff_blit_buff_toNC()\n\n"));
}

/*+------------------------------------------------------------------------+*/
/*|blit a portion of a buffer to another buffer with clipping              |*/
/*+------------------------------------------------------------------------+*/
#undef LIBDEBUG
#ifdef __DEBUG_buff_blit_buff_to
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

#ifndef _SWAP
#define _SWAP(a,b) a^=b;b^=a;a^=b
#endif

inline void buff_blit_buff_to(buffer_rec *dbuff, USHORT dbfx, USHORT dbfy,
		     buffer_rec *sbuff,USHORT sbx1, USHORT sby1,USHORT sbx2, USHORT sby2)
{
 int v_iterations;
 unsigned int h_len;

 UBYTE *src=B_BUFF_PTR(sbuff),*dest=B_BUFF_PTR(dbuff);
 USHORT sbuffx=B_X_SIZE(sbuff),dbuffx=B_X_SIZE(dbuff),dbuffy=B_Y_SIZE(dbuff);

 LIBDEBUG(printf("\nEntering buff_blit_buff_to()\n\n"));

 /* sort coordinates if needed */
 if(sbx2<sbx1){
    _SWAP(sbx1,sbx2);
 }
 if(sby2<sby1){
    _SWAP(sby1,sby2);
 }

 /* test coordinates for "don't draw" clipping */
 if((dbfx > dbuffx) || (dbfy > dbuffy)){
    return;
 }

 src+=(sby1*sbuffx)+sbx1;
 dest+=(dbfy*dbuffx)+dbfx;

 v_iterations=(sby2-sby1); /* number of times to repeat horiz. blit */
 h_len=(sbx2-sbx1);  /* length of horizontal blit */

 /* test coordinates to clip area drawn */
 if(dbfx+h_len > dbuffx){
   h_len = dbuffx-dbfx;
 }
 if(dbfy+v_iterations > dbuffy){
   v_iterations = dbuffy-dbfy;
 }

 switch(get_copy_method2((unsigned int)src,(unsigned int)dest,h_len)){

   case USE_SB:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sb(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_SW:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sw(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case INC_USE_SW:
	for(;v_iterations!=0;v_iterations--){
	    _copy_inc_sw(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_SW_INC:
	for(;v_iterations!=0;v_iterations--){
	    _copy_sw_inc(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   case USE_INC_SW_INC:
	for(;v_iterations!=0;v_iterations--){
	    _copy_inc_sw_inc(src,dest,h_len);
	    src += sbuffx;
	    dest += dbuffx;
	}
	break;

   default:
	LIBDEBUG(printf("\nUnknown value returned from get_copy_method()\n\n"));
	exit(0);
	break;
 }

 LIBDEBUG(printf("\nLeaving buff_blit_buff_to()\n\n"));
}

/*+------------------------------------------------------------------------+*/
/*|blit a portion of an image to a buffer with clipping                    |*/
/*+------------------------------------------------------------------------+*/
#undef LIBDEBUG
#ifdef __DEBUG_buff_blit_img_to
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

/* note: this routine relies on the arrangement of memory in buffers remaining
**      same as memory in images.  This is therefore a devious way of performing
**      this function, and it will die if the buffer or image structs are
**      substantially changed.  You have been warned,  Jon!
*/

inline void buff_blit_img_to(buffer_rec *dbuff, USHORT dbfx, USHORT dbfy,
		     image *img,USHORT imx1, USHORT imy1,USHORT imx2, USHORT imy2)
{
 buffer_rec fake_buff;

 LIBDEBUG(printf("\nEntering buff_blit_img_to()\n\n"));

 /* fake the image -> buffer copy as a buff to buff copy */
 fake_buff.width  = img->width;
 fake_buff.height = img->height;
 fake_buff.buffer = img->data;

 /* do blit */
 buff_blit_buff_to(dbuff,dbfx,dbfy,&fake_buff,imx1,imy1,imx2,imy2);


 LIBDEBUG(printf("\nLeaving buff_blit_img_to()\n\n"));
}

/*+------------------------------------------------------------------------+*/
/*|blit a portion of an image to a buffer without clipping                 |*/
/*+------------------------------------------------------------------------+*/
#undef LIBDEBUG
#ifdef __DEBUG_buff_blit_img_toNC
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

/* note: this routine relies on the arrangement of memory in buffers remaining
**      same as memory in images.  This is therefore a devious way of performing
**      this function, and it will die if the buffer or image structs are
**      substantially changed.  You have been warned,  Jon!
*/

inline void buff_blit_img_toNC(buffer_rec *dbuff, USHORT dbfx, USHORT dbfy,
		     image *img,USHORT imx1, USHORT imy1,USHORT imx2, USHORT imy2)
{
 buffer_rec fake_buff;

 LIBDEBUG(printf("\nEntering buff_blit_img_toNC()\n\n"));

 /* fake the image -> buffer copy as a buff to buff copy */
 fake_buff.width  = img->width;
 fake_buff.height = img->height;
 fake_buff.buffer = img->data;

 /* do blit */
 buff_blit_buff_toNC(dbuff,dbfx,dbfy,&fake_buff,imx1,imy1,imx2,imy2);


 LIBDEBUG(printf("\nLeaving buff_blit_img_toNC()\n\n"));
}

