/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/
#include <string.h>
#include "..\jlib.h"

#define ABS(a)   ((a < 0) ? -a : a)
#define SGN(a)   ((a < 0) ? -1 : 1)

/*+-------------------------------------------------------------------------+*/
/*|draw a line from x1, y1 to x2, y2 in color c                             |*/
/*|                                                                         |*/
/*|this function uses a pathetic excuse for clipping but it will have to do |*/
/*|for the moment.                                                          |*/
/*+-------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buff_draw_line
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_line(buffer_rec *buff,USHORT x1, USHORT y1, USHORT x2, USHORT y2, UBYTE c)
{
 int d, x, y, ax, ay, sx, sy, dx, dy;
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);
 USHORT height=B_Y_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_line()\n\n"));

 /* clip the points (sigh) */
 if(x1 > width){
    x1=width;
 }

 if(x2 > width){
    x2=width;
 }

 if(y1 > height){
    y1=height;
 }

 if(y2 > height){
    y2=height;
 }

 dx = x2-x1;
 ax = ABS(dx) << 1;
 sx = SGN(dx);
 dy = y2-y1;
 ay = ABS(dy) << 1;
 sy = SGN(dy);

 x = x1;
 y = y1;

 if( ax > ay ){
    d = ay - (ax >> 1);
    while( x != x2 ){
	 buffer[(width*y)+x]=c;
	if( d >= 0 ){
	   y += sy;
	   d -= ax;
	}
	x += sx;
	d += ay;
    }
 }
 else{
     d = ax - (ay >> 1);
     while( y != y2 ){
	 buffer[(width*y)+x]=c;
	 if( d >= 0 ){
	    x += sx;
	    d -= ay;
	 }
	 y += sy;
	 d += ax;
     }
 }

 LIBDEBUG(printf("\nLeaving buff_draw_line()\n\n"));
}

/*+-------------------------------------------------------------------------+*/
/*|draw a line from x1, y1 to x2, y2 in color c                             |*/
/*+-------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buff_draw_lineNC
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_lineNC(buffer_rec *buff,USHORT x1, USHORT y1, USHORT x2, USHORT y2, UBYTE c)
{
 int d, x, y, ax, ay, sx, sy, dx, dy;
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_line_NC()\n\n"));

 dx = x2-x1;
 ax = ABS(dx) << 1;
 sx = SGN(dx);
 dy = y2-y1;
 ay = ABS(dy) << 1;
 sy = SGN(dy);

 x = x1;
 y = y1;

 if( ax > ay ){
    d = ay - (ax >> 1);
    while( x != x2 ){
	 buffer[(width*y)+x]=c;
	if( d >= 0 ){
	   y += sy;
	   d -= ax;
	}
	x += sx;
	d += ay;
    }
 }
 else{
     d = ax - (ay >> 1);
     while( y != y2 ){
	 buffer[(width*y)+x]=c;
	 if( d >= 0 ){
	    x += sx;
	    d -= ay;
	 }
	 y += sy;
	 d += ax;
     }
 }

 LIBDEBUG(printf("\nLeaving buff_draw_line_NC()\n\n"));
}


/*+------------------------------------------------------------------------+*/
/*|draw a horizontal line from x1, y1 to x2 in color c with clipping       |*/
/*+------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buffer_draw_h_line
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_h_line(buffer_rec *buff,USHORT x1, USHORT y1, USHORT x2, UBYTE c)
{
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);
 USHORT height=B_Y_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_h_line()\n\n"));

 if(x1 > x2){
    x2^=x1;
    x1^=x2;      /* swap ends around */
    x2^=x1;
 }

 /* clip points */
 if((x1 >= width) || (y1 >= height)){
    return;
 }

 if(x2 > width){
    x2 = width;
 }

 buffer+=(width*y1)+x1;
 memset(buffer,(int)c,(size_t)x2-x1);

 LIBDEBUG(printf("\nLeaving buff_draw_h_line()\n\n"));
}

/*+------------------------------------------------------------------------+*/
/*|draw a horizontal line from x1, y1 to x2 in color c without clipping    |*/
/*+------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buff_draw_h_lineNC
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_h_lineNC(buffer_rec *buff,USHORT x1, USHORT y1, USHORT x2, UBYTE c)
{
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_h_line_NC()\n\n"));

 if(x1 > x2){
    x2^=x1;
    x1^=x2;      /* swap ends around */
    x2^=x1;
 }

 buffer+=(width*y1)+x1;

 memset(buffer,(int)c,(size_t)x2-x1);

 LIBDEBUG(printf("\nLeaving buff_draw_h_line_NC()\n\n"));
}


/*+------------------------------------------------------------------------+*/
/*|draw a vertical line from x1, y1 to x2 in color c with clipping         |*/
/*+------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buff_draw_v_line
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_v_line(buffer_rec *buff,USHORT x1, USHORT y1, USHORT y2, UBYTE c)
{
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);
 USHORT height=B_Y_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_v_line()\n\n"));

 if(y1 > y2){
    y2^=y1;
    y1^=y2;      /* swap ends around */
    y2^=y1;
 }

 /* clip coords if needed */
 if((y1 > height) || (x1 > width)){
    return;
 }

 if(y2 > height){
    y2=height;
 }

 buffer+=(width*y1)+x1;

 for(;y2>y1;y2--){
     *buffer=c;
     buffer+=width;
 }

 LIBDEBUG(printf("\nLeaving buff_draw_v_line()\n\n"));
}


/*+------------------------------------------------------------------------+*/
/*|draw a vertical line from x1, y1 to x2 in color c without clipping      |*/
/*+------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_buff_draw_v_lineNC
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

void buff_draw_v_lineNC(buffer_rec *buff,USHORT x1, USHORT y1, USHORT y2, UBYTE c)
{
 UBYTE *buffer=B_BUFF_PTR(buff);
 USHORT width=B_X_SIZE(buff);

 LIBDEBUG(printf("\nEntering buff_draw_v_lineNC()\n\n"));

 if(y1 > y2){
    y2^=y1;
    y1^=y2;      /* swap ends around */
    y2^=y1;
 }

 buffer+=(width*y1)+x1;

 for(;y2>y1;y2--){
     *buffer=c;
     buffer+=width;
 }

 LIBDEBUG(printf("\nLeaving buff_draw_v_lineNC()\n\n"));
}

