/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/
#include "..\memcopy.h"

#define MASK_1 0x00000001
#define MASK_16s 0xfffffff0

/* Note that this routine expects that the addresses passed to it will be  **
** cast to unsigned int. The masks above assume 32 bit ints.               */

/* return the best copy method for two addresses and a length */
inline int get_copy_method2(unsigned int addr1,unsigned int addr2,unsigned int len)
{
 if(len & MASK_16s){
    /* len is > 16 */
    addr1+=addr2;

    if(addr1 & MASK_1){
      /* one address is odd, one is even */
      return USE_SB;
    }
    else{
      /* both address are either odd or even */
      if(addr2 & MASK_1){
	 /* both are odd */
	 if(len & MASK_1){
	    return INC_USE_SW;  /* length is odd */
	 }
	 else{
	    return USE_INC_SW_INC;  /* length is even */
	 }
      }
      else{
	 /* both are even */
	 if(len & MASK_1){
	    return USE_SW_INC;  /* length is odd */
	 }
	 else{
	    return USE_SW;      /* length is even */
	 }
      }
    }
 }
 else{
    /* len is <= 16, use sb */
    return USE_SB;
 }
}

