/*
	This file implements all the dib stuff in a C++ manner
	that is not as sloppy as the MS way............

	Mark Gross June 3 1995
*/

#ifndef __DIBSTUFF__
#define __DIBSTUFF__

#ifdef __cplusplus
extern "C" {
#endif

typedef LPBITMAPINFOHEADER PDIB;
typedef HANDLE HDIB;
typedef BYTE huge *HPBYTE;

PDIB WINAPI DibOpenFile(LPSTR szFile);
BOOL WINAPI DibWriteFile(PDIB pdib, LPSTR szFile);
PDIB WINAPI DibReadBitmapInfo(HFILE fh);
HPALETTE WINAPI DibCreatePalette(PDIB pdib);
BOOL WINAPI DibSetUsage(PDIB pdib, HPALETTE hpal,UINT wUsage);
BOOL WINAPI DibDraw(HDC hdc, int x, int y, int dx, int dy, PDIB pdib, int x0, int y0, int dx0, int dy0, LONG rop, UINT wUsage);
PDIB WINAPI DibCreate(int bits, int dx, int dy);
PDIB WINAPI DibCopy(PDIB pdib);
void WINAPI DibMapToPalette(PDIB pdib, HPALETTE hpal);
PDIB WINAPI DibConvert(PDIB pdib, int BitCount, DWORD biCompression);
//PDIB WINAPI DibHalftoneDIB(PDIB pdib);

PDIB WINAPI DibFromBitmap(HBITMAP hbm, DWORD biStyle, UINT biBits, HPALETTE hpal, UINT wUsage);
HBITMAP WINAPI BitmapFromDib(PDIB pdib, HPALETTE hpal, UINT wUsage);

void WINAPI MakeIdentityPalette(HPALETTE hpal);
HPALETTE WINAPI CopyPalette(HPALETTE hpal);

BOOL WINAPI DibIsRectEmpty(PDIB pdib, LPRECT pRect, BYTE bTransparent);
BOOL WINAPI DibIsRectFull(PDIB pdib, LPRECT pRect, BYTE bTransparent);
DWORD WINAPI DibCountRectPixels(PDIB pdib, LPRECT pRect, BYTE bTransparent);
unsigned short WINAPI DibFindColor(PDIB pdib, COLORREF color);

HPBYTE WINAPI GetDIBPixelAddress(PDIB pdib, UINT x, UINT y);
BYTE WINAPI GetDIBPixelValue(PDIB pdib, UINT x, UINT y);
COLORREF WINAPI GetDIBPixelColor(PDIB pdib, UINT x, UINT y);

//void WINAPI DeltaFrame386(PDIB pdib, LPBYTE pbitsPrev, LPBYTE pbitsCur, LPBYTE pbitsRLE);
void WINAPI DecodeRle(LPBITMAPINFOHEADER lpbi, HPBYTE pb, HPBYTE prle);

/****************************************************************************
 DIB macros.
 ***************************************************************************/
inline HANDLE HandleFromDib(LPBITMAPINFOHEADER lpbi);
inline PDIB DibFromHandle(HGLOBAL h);
inline void DibFree(PDIB pdib);
inline unsigned long WIDTHBYTES(long cbits);
inline  long DibWidth(PDIB pdib);
inline  long DibHeight(PDIB pdib);
inline unsigned short DibBitCount(PDIB pdib);
inline unsigned long DibCompression(PDIB pdib);
inline  long DibWidthBytesN(PDIB pdib, long n);
inline  long DibWidthBytes(PDIB pdib);
inline  long DibStorageWidth(PDIB pdib);
inline LPSTR DibPBits(PDIB pdib);
inline LPRGBQUAD DibPCLRTAB(PDIB pdib);
inline  long DibPitch(PDIB pdib);
inline  unsigned long DibSizeImage(PDIB pdib);
inline unsigned long DibSizeColors(PDIB pdib);
inline unsigned long DibPaletteSize(LPBITMAPINFOHEADER lpbi);
inline unsigned long DibSizeHeader(PDIB pdib);
inline unsigned long DibSize(PDIB pdib);
inline short DibFlipY(LPBITMAPINFOHEADER lpbi, short y);
inline LPVOID DibPtr(LPBITMAPINFOHEADER lpbi);
inline RGBQUAD FAR *DibColors(LPBITMAPINFOHEADER lpbi);
inline unsigned long  DibNumColors(LPBITMAPINFOHEADER lpbi);
inline LPVOID DibXYN(LPBITMAPINFOHEADER lpbi,HPBYTE pb,unsigned short x,unsigned short y,unsigned short n);
inline LPVOID DibXY(LPBITMAPINFOHEADER lpbi,unsigned short x,unsigned short y);
inline void FixBitmapInfo(LPBITMAPINFOHEADER lpbi);
inline BITMAPINFO FAR * DibInfo(PDIB pDIB);

/****************************************************************************
 ***************************************************************************/

#ifndef BI_BITFIELDS
	#define BI_BITFIELDS 3
#endif

#ifndef HALFTONE
	#define HALFTONE COLORONCOLOR
#endif

#ifdef __cplusplus
}
#endif

#include "dibstuf2.cpp"

#endif // __DIBSTUFF__