;******************************************************************************
; Filename: FINDFIRST.ASM
;   Author: Adam Seychell
;  Version: 0.0
;  Created: 1995.09.11
;******************************************************************************
; Copyright Adam Seychell, 1994.
; All rights reserved.
;******************************************************************************
; Function: int findfirst(const char *pathname, struct ffblk *ffblk, int attrib);
;  Comment: Returns the length of a file in bytes
;    Input: Eax, handle - file handle
;           Edx, pointer to ffblk structure to store data.
;           Ecx, attributes
;  Returns: 0 if successful, or -1 if an error occured with errno set.
;******************************************************************************
		Include STDDEF.INC

		Codeseg

Proc    findfirst ,3

		Mov		Ah,4Eh
		Int		21h
		Jc		@@error
		Mov		Edx,[_psp]
		Add		Edx,80h
		Mov		Ecx,(Size ffblk)
		call	@memcpy
		Clear	Eax
		Ret
@@error:
        And     Eax,0ffh
		Mov     [errno],Eax
		Mov		Eax,-1
		Ret

Endp

        End
