;****************************************************************************
; Filename: FPRINTF.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.02.09
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: ULONG fprintf(FILE * file_ptr,PSZ fmtstr,...);
;  Comment: Prints a formatted string to a file stream and returns the
;           number of written characters.
;    Input: file_ptr - file stream pointer
;           fmtstr - fprintf format string
;           ... - possible arguments
;   Output: Number of characters written or EOF
;****************************************************************************

        Include STDDEF.INC

        Codeseg

Proc    fprintf
                Mov         Edx,[Esp+8]
                Lea         Ecx,[Esp+12]
                Sub         Esp,1024                ; Allocates a 1024 bytes buffer from
                Mov         Eax,Esp                         ; the stack...
                Call    @vprintf
                Mov         Ecx,Eax
                Mov     Eax,Esp
        Mov     Edx,1
                Push    [DWORD Esp+1024+4]  ; Get the file pointer
                Call    @fwrite
                Add         Esp,1024+4
                Ret
Endp    fprintf

        End
