/*
  File name:  DTFMAKER.CPP
  Created by: Andrew Hanenkamp
		of Dual Tech Software Development
  Created on: May 5, 1995
  Purpose:  To create fonts for later use by Dual Tech programs, or other
  programmers if eventually made public.

  Copyright (c) 1995.  All Rights Reserved.
*/

//#include <graphics.h>	//for graphics
#include <stdio.h>	//for printf()
#include <conio.h>	//for getch()
#include <string.h>	//for strcmp(), strcpy()
#include "dtf_use.h"
#include "graph.h"

#define BIT0	0x80
#define BIT1	0x40
#define BIT2	0x20
#define BIT3	0x10
#define BIT4	0x08
#define BIT5	0x04
#define BIT6	0x02
#define BIT7	0x01

#define CURSOR_X_LEN	9
#define CURSOR_Y_LEN	11

#define FINISHIT	ofc++; omx = -1; omy = -1; \
			finished = 1;

int c_char = 0;		//current character selected
DTFont font(BIOS);	//font class for work with disk
DTF_Font f;		//holds font
DTFont bios(BIOS);	//font used by dtfmaker
unsigned int character_size;

RGB_color pal[256];

int done = 0;

unsigned int ofc = 16, forecolor = 15, backcolor = 0;

int curs_x = 0, curs_y = 0;

int rel_x, rel_y;
int b1, b2;
int redraw = 1;


void Introduction()
{
  SetMode(0x3);
  gotoxy(26, 8);
  textbackground(BLACK);
  textcolor(WHITE);
  cprintf("Welcome to DTFont Maker v1.0");
  gotoxy(29, 9);
  cprintf("by Andrew Hanenkamp");
  gotoxy(23, 10);
  cprintf("of Dual Tech Software Development");
  gotoxy(9, 12);
  cprintf("Copyright (c) 1995 to Andrew Hanenkamp.  All Rights Reserved.");
  gotoxy(31, 14);
  textcolor(LIGHTRED);
  cprintf("SHAREWARE VERSION");
  gotoxy(31, 15);
  textcolor(LIGHTGREEN);
  cprintf("Please distribute!");
  textcolor(LIGHTGRAY);
  gotoxy(32, 25);
  cprintf("Press any key...");
  getch();
}

void Draw_Screen()
{
  if(redraw) {
    redraw = 0;
    Bar(0, 0, f.h.width*3+1, f.h.height*3+1, BLACK);
    Rectangle(0, 0, f.h.width*3+1, f.h.height*3+1, WHITE);
    if(f.h.bits_per_pixel == 1) {
      unsigned char bit_mask = 0x80>>((f.h.height*f.h.width*c_char)%8);
      unsigned long offset = ((unsigned long)c_char)*(unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
      for(int y = 0; y < f.h.height; y++) {
	for(int x = 0; x < f.h.width; x++) {
	  if((*(f.character+offset) & bit_mask))
	    Bar(x*3+1, y*3+1, x*3+3, y*3+3, forecolor);
	  else
	    Bar(x*3+1, y*3+1, x*3+3, y*3+3, backcolor);
	  if(bit_mask == 0x01) {
	    offset++;
	    bit_mask = 0x80;
	  }
	  else bit_mask >>= 1;
	}
      }
    }
    else if(f.h.bits_per_pixel == 8) {
      unsigned long offset = (unsigned long)c_char*(unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
      for(int y = 0; y < f.h.height; y++) {
	for(int x = 0; x < f.h.width; x++) {
	  Bar(x*3+1, y*3+1, x*3+3, y*3+3, *(f.character+offset));
	  offset++;
	}
      }
    }


    Rectangle(229, 0, 319, 10, WHITE);
    bios.Putstr(230, 1, "- char", WHITE);
    Rectangle(229, 10, 319, 20, WHITE);
    bios.Putstr(230, 11, "+ char", WHITE);
    Rectangle(229, 20, 319, 30, WHITE);
    bios.Putstr(230, 21, "Save font", WHITE);
    Rectangle(229, 30, 319, 40, WHITE);
    bios.Putstr(230, 31, "Load font", WHITE);
    Rectangle(229, 40, 319, 50, WHITE);
    bios.Putstr(230, 41, "Default", WHITE);
    Rectangle(229, 50, 319, 60, WHITE);
    bios.Putstr(230, 51, "From pcx...", WHITE);
    Rectangle(229, 60, 319, 70, WHITE);
    bios.Putstr(230, 61, "New font", WHITE);
    Rectangle(229, 70, 319, 80, WHITE);
    bios.Putstr(230, 71, "Quit", WHITE);

    bios.Set_Clear(1);
    Bar(230, 82, 248, 100, forecolor);
    bios.Putch(235, 87, 'F', BLACK);
    Bar(255, 82, 273, 100, backcolor);
    bios.Putch(260, 87, 'B', WHITE);
    bios.Set_Clear(0);

    char buf[31];
    if(ofc != forecolor) {
      Bar(229, 105, 319, 188, forecolor);
      Bar(230, 110, 318, 187, BLACK);
      bios.Putstr(240, 111, "R  G  B", WHITE);
      RGB_color color;
      Get_Palette_Register(forecolor, &color);
      sprintf(buf, "%d ", color.red);
      bios.Putstr(240, 121, buf, WHITE);
      sprintf(buf, "%d ", color.green);
      bios.Putstr(264, 121, buf, WHITE);
      sprintf(buf, "%d ", color.blue);
      bios.Putstr(288, 121, buf, WHITE);
      for(int i = 0; i < 4; i++) {
	VLine(242+i, 185-color.red*8/9, 185, WHITE);
	VLine(266+i, 185-color.green*8/9, 185, WHITE);
	VLine(290+i, 185-color.blue*8/9, 185, WHITE);
      }
      ofc = forecolor;
    }

    sprintf(buf, "#%d      ", c_char);
    bios.Putstr(230, 190, buf, WHITE);

//    Rectangle(146, 0, 227, 82, WHITE);
    for(int x = 0; x < 16; x++)
      for(int y = 0; y < 16; y++)
	Bar(x*5+147, y*5+1, x*5+151, y*5+5, x+y*16);
    int f_mod = forecolor%16, f_div = forecolor/16;
    int b_mod = backcolor%16, b_div = backcolor/16;
    if(forecolor != backcolor) {
      Rectangle(f_mod*5+147, f_div*5+1, f_mod*5+151, f_div*5+5, BLACK);
      Rectangle(b_mod*5+147, b_div*5+1, b_mod*5+151, b_div*5+5, WHITE);
    }
    else {
      Rectangle(f_mod*5+147, f_div*5+1, f_mod*5+151, f_div*5+5, BLACK);
      Rectangle(b_mod*5+148, b_div*5+2, b_mod*5+150, b_div*5+4, WHITE);
    }

    if(c_char != 0)
      font.Putch(0, 199-f.h.height, c_char-1, forecolor);
    else
      font.Putch(0, 199-f.h.height, f.h.character_num-1, forecolor);
    font.Putch(f.h.width+4, 199-f.h.height, c_char, forecolor | backcolor<<8);
    if(c_char != f.h.character_num-1)
      font.Putch((f.h.width+4)*2, 199-f.h.height, c_char+1, forecolor);
    else
      font.Putch((f.h.width+4)*2, 199-f.h.height, 0, forecolor);
  }
}

void Mouse_Pos(void)
{
  int bt;
  asm mov ax, 0x03
  asm int 0x33
  asm mov bt, bx

  asm mov ax, 0x0B
  asm int 0x33
  asm mov rel_x, cx
  asm mov rel_y, dx

  b1 = bt & 0x01;
//middle button = bt & 0x02
  b2 = bt & 0x02;
}

void Save_Font()
{
  char file_name[14];

  Save_Palette(pal);
  SetMode(0x3);
  printf("Enter file to save:  ");
  if(kbhit() == '\r')
    getch();
  gets(file_name);
  SetMode(0x13);
  Restore_Palette(pal);
  ofc++; omx = -1; omy = -1;

  if(f.palette.color_num > 0)
    for(int i = 0; i < f.palette.color_num; i++)
      Get_Palette_Register(i+f.palette.color_offset, f.palette.color+i);

  font.Create(&f);

  if(!font.Save(file_name)) {
    Save_Palette(pal);
    SetMode(0x3);
    puts("Error: Cannot open file. Press return...");
    while(getch() != '\r');
    SetMode(0x13);
    Restore_Palette(pal);
    return;
  }
}

void Delete_Temp_Font(DTF_Font far *f)
{
  if(f->s.space_string != NULL)
    farfree(f->s.space_string);
  if(f->character != NULL)
    farfree(f->character);
  if(f->palette.color != NULL)
    farfree(f->palette.color);
  f->s.space_string = NULL;
  f->character = NULL;
  f->palette.color = NULL;
}

void Load_Font()
{
  char file_name[14];

  Save_Palette(pal);
  SetMode(0x3);
  printf("Enter the file to load:  ");
  if(kbhit() == '\r')
    getch();
  gets(file_name);
  SetMode(0x13);
  Restore_Palette(pal);
  ofc++; omx = -1; omy = -1;

  if(!font.Load(file_name)) {
    Save_Palette(pal);
    SetMode(0x3);
    puts("Error: Cannot open file. Press a key...");
    while(getch() != '\r');
    SetMode(0x13);
    Restore_Palette(pal);
    return;
  }

  Delete_Temp_Font(&f);
  font.Retrieve(&f);
  font.Load_Palette();
  character_size = (unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
  c_char = 0;
}

void PCX_2_Font(char far *character, unsigned int c, char far *pcx_src,
	unsigned long x, unsigned long y, unsigned long bpp, unsigned long fw,
	unsigned long fh)
{
  unsigned long offset;
  unsigned char bit_mask;

  character += ((c*fh*fw*bpp)/8);

  offset = (y<<8)+(y<<6)+x;
  (*character) = 0;
  if(f.h.bits_per_pixel == 1) {
    bit_mask = 0x80>>((fh*fw*bpp*c)%8);
    for(unsigned int j = 0; j < fh; j++) {
      for(unsigned int i = 0; i < fw; i++) {
	if(pcx_src[offset+i])
	  (*character) |= bit_mask;

	if(bit_mask == 0x01) {
	  character++;
	  bit_mask = 0x80;
	}
	else
	  bit_mask >>= 1;
      }
      offset += 320;
    }
  }
  else if(f.h.bits_per_pixel == 8) {
    for(unsigned int j = 0; j < fh; j++) {
      for(unsigned int i = 0; i < fw; i++) {
	(*character) = pcx_src[offset+i];
	character++;
      }
      offset += 320;
    }
  }
  font.Create(&f);
}


void Get_Character_From()
{
  char file_name[14];

  Save_Palette(pal);
  SetMode(0x3);
  printf("Enter file name [DTFFONT.PCX]:  ");
  gets(file_name);
  SetMode(0x13);
  Restore_Palette(pal);

  pcx_picture image;

  if(!strcmp(file_name, ""))
    strcpy(file_name, "dtffont.pcx");
  PCX_Init(&image);
  if(!PCX_Load(file_name, &image, 0)) {
    SetMode(0x3);
    puts("Error: Cannot open file.  Press any key...");
    getch();
    SetMode(0x13);
    return;
  }
  PCX_Show_Buffer(&image);

  int ox = curs_x+1, oy = curs_y+1;
  Init_Rectangle_Cursor(f.h.width, f.h.height);
  while(!b1) {
    Mouse_Pos();

    if(ox != curs_x || oy != curs_y)
      Rectangle_ABuffed(curs_x, curs_y);

    ox = curs_x;
    oy = curs_y;
    curs_x += rel_x;
    curs_y += rel_y;
    curs_x = curs_x >= 320 ? 320 : curs_x;
    curs_x = curs_x < 0 ? 0 : curs_x;
    curs_y = curs_y >= 200 ? 200 : curs_y;
    curs_y = curs_y < 0 ? 0 : curs_y;

    if(b1) {
      while(b1)
	Mouse_Pos();
      b1 = 1;
    }
  }
  Destroy_Rectangle_Cursor();
  Bar(0, 0, 319, 299, BLACK);

  PCX_2_Font(f.character, c_char, image.buffer, curs_x, curs_y,
		f.h.bits_per_pixel, f.h.width, f.h.height);
  omx = -1; omy = -1;
  PCX_Delete(&image);
}

void Create_New_Font()
{
  Save_Palette(pal);
  Delete_Temp_Font(&f);
  int error = 1;
  do {
    SetMode(0x3);
    printf("You have %ld bytes left in memory.\n", farcoreleft());
    printf("Enter new height:  ");
    scanf("%d", &f.h.height);
    printf("Enter new width:  ");
    scanf("%d", &f.h.width);
    printf("Enter number of bits/pixel (1 or 8):  ");
    scanf("%d", &f.h.bits_per_pixel);
    printf("Enter number of characters:  ");
    scanf("%d", &f.h.character_num);
    printf("Enter clear pixel (Usually 0):  ");
    scanf("%d", &f.h.clear_pixel);
    printf("Set spacing option: \
	    \n 0. Monospaced \
	    \n 1. Mono_Script \
	    \n 2. Script \
	    \n 3. Normal_Space \
	    \n 4. Font_Defined_Space \
	    \nChoose:  ");
    scanf("%d", &f.s.space);
    if(f.s.space == 4) {
      f.s.space_string = (char far *)farmalloc(f.h.character_num);
      for(int i = 0; i < f.h.character_num; i++)
	f.s.space_string[i] = f.h.width;
    }
    else
      f.s.space_string = NULL;
    printf("Enter number of colors included in palette:  ");
    scanf("%d", &f.palette.color_num);
    printf("Enter offset of color palette from 0:  ");
    scanf("%d", &f.palette.color_offset);
    long font_size = ((unsigned int)f.h.height)*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel*(unsigned int)f.h.character_num/8U+1U;
    long palette_size = f.palette.color_num*3;
    long space_size = f.s.space != 4 ? f.h.character_num : 0;
    if(font_size+palette_size+space_size > farcoreleft()) {
      printf("\nI'm sorry, but you do not have enough memory to create a font\
	      \nthis size:\
	      \nBytes Left:	 %ldkb\
	      \nFont size:	 %ldkb\
	      \nPalette size:	 %ldkb\
	      \nKern size:	 %ldkb (only if space option 4)\
	      \nTotal font size: %ldkb\
	      \nMemory exceeded by: %ldkb", farcoreleft(), font_size,
			palette_size, space_size, font_size+palette_size+space_size,
			farcoreleft()-(font_size+palette_size+space_size));
      getch();
    }
    else
      error = 0;
  } while(error);
  character_size = (unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
  f.character = (char far *)farmalloc((unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel*f.h.character_num/8);
  for(int i = 0; i < (unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel*f.h.character_num/8; i++)
    (*(f.character+i)) = 0;
  f.palette.color = (RGB_color_ptr)farmalloc(f.palette.color_num*sizeof(RGB_color));
  font.Create(&f);
  SetMode(0x13);
  c_char = 0;
  Restore_Palette(pal);
  if(f.palette.color_num > 0)
    for(i = 0; i < f.palette.color_num; i++)
      Get_Palette_Register(i+f.palette.color_offset, f.palette.color+i);
  ofc++; omx = -1; omy = -1;
}

void Help_Screen()
{
  Save_Palette(pal);
  SetMode(0x3);
  puts(" Help Screen");
  puts("-------------");
  puts("");
  puts("(F1)	Help (or H or ?)");
  puts("(Q)	Quit");
  puts("(R)	Reset Palette (sets palette to startup palette)");
  puts("(P)	Palette from PCX");
  puts("(S)	Save Font");
  puts("(D)	Default Font (gets the 8x8 BIOS font)");
  puts("(F)	Retrieve character from a PCX");
  puts("(L)	Load Font");
  puts("(N)	New Font (starts new font from scratch)");
  puts("(T)	Test Font, Change Space Settings");
  puts("(G)	Goto Character #");
  puts("(-)	Character -1");
  puts("(+)	Character +1");
  puts("([)	Foreground color -1");
  puts("(])	Foreground color +1");
  puts("(SHF+[)	Foreground color -16");
  puts("(SHF+])	Foreground color +16");
  puts("(<)	Background color -1");
  puts("(>)	Background color +1");
  puts("(SHF+<)	Background color -16");
  puts("(SHF+>)	Background color +16");
  puts("Press a key to continue...");
  getch();
  SetMode(0x3);

  puts(" Help Screen (cont'd)");
  puts("----------------------");
  puts("");
  puts("(7)	Red +1");
  puts("(8)	Green +1");
  puts("(9)	Blue +1");
  puts("(1)	Red -1");
  puts("(2)	Green -1");
  puts("(3)	Blue -1");
  puts("(HOME)	Red +4");
  puts("(UP)	Green +4");
  puts("(PGUP)	Blue +4");
  puts("(END)	Red -4");
  puts("(DOWN)	Green -4");
  puts("(PGDN)	Blue -4");
  puts("Press a key to continue...");
  getch();

  SetMode(0x13);
  omx = -1; omy = -1;
  Restore_Palette(pal);
  ofc++; omx = -1; omy = -1;
}

void Test_String()
{
  Save_Palette(pal);
  SetMode(0x3);
  char teststring[321];
  printf("Enter string to test font with (%d characters max.):\n", 320/f.h.width);
  gets(teststring);
  SetMode(0x13);
  Restore_Palette(pal);
  int color = forecolor | (backcolor<<8);
  if(f.s.space != 4) {
    font.Putstr(0, 0, teststring, color);
    bios.Putstr(0, 80, "Press a key...", color);
    getch();
    Bar(0, 0, 319, 199, BLACK);
  }
  else {
    int complete = 0;
    char buf[31];
    while(!complete) {
      font.Putstr(0, 0, teststring, color);
      font.Putch(0, 71, c_char, color);
      sprintf(buf, "Character #%d, Kern width = %d", c_char, f.s.space_string[c_char]);
      bios.Putstr(0, 80, buf, color);
      bios.Putstr(0, 89, "+,- Adjust current character", color);
      bios.Putstr(0, 98, "<,> Adjust space width", color);
      bios.Putstr(0, 107, "Hit return when finished", color);
      switch(getch()) {
	case '_': case '-':
		if(c_char > 0) c_char--;
		else c_char = f.h.character_num-1;
		break;
	case '+': case '=':
		if(c_char < f.h.character_num-1) c_char++;
		else c_char = 0;
		break;
	case '<': case ',':
		f.s.space_string[c_char]--;
		font.Create(&f);
		break;
	case '>': case '.':
		f.s.space_string[c_char]++;
		font.Create(&f);
		break;
	case '\r': complete = 1; break;
      }
      Bar(0, 0, 319, 199, backcolor);
    }
  }
}

void Get_Task()
{
  int finished = 0;
  char ch;
  static int last_time_x = 0, last_time_y = 0;
  while(!finished) {
    Mouse_Pos();
    if(kbhit())
      ch = getch();

    curs_x += rel_x;
    curs_y += rel_y;

    if(rel_x != 0 || rel_y != 0) {
      redraw = -1;
      finished = 1;
    }

    curs_x = curs_x >= 320 ? 320 : curs_x;
    curs_x = curs_x < 0 ? 0 : curs_x;
    curs_y = curs_y >= 200 ? 200 : curs_y;
    curs_y = curs_y < 0 ? 0 : curs_y;

    if(curs_x >= 1 && curs_x < f.h.width*3+1 && curs_y >= 1 && curs_y < f.h.height*3+1 && !(b1 || b2)) {
      last_time_x = -1;
      last_time_y = -1;
    }

    if(b1) {
      if(!(curs_x >= 0 && curs_x < 146 && curs_y >= 0 && curs_y < 146))
	while(b1)
	  Mouse_Pos();

      if(curs_x >= 1 && curs_x < f.h.width*3+1 && curs_y >= 1 && curs_y < f.h.height*3+1)
	finished = 1;

      if(curs_x >= 0 && curs_x < f.h.width*3+1 && curs_y >= 0 && curs_y < f.h.height*3+1 && (last_time_x != (curs_x-1)/3 || last_time_y != (curs_y-1)/3)) {
	last_time_x = (curs_x-1)/3;
	last_time_y = (curs_y-1)/3;
	if(((curs_y-1)/3) < f.h.height && ((curs_x-1)/3) < f.h.width) {
	  int x = (curs_x-1)/3, y = (curs_y-1)/3;
	  unsigned long offset;
	  if(f.h.bits_per_pixel == 1) {
	    unsigned char bit_mask = 0x80>>((x+y*f.h.width+c_char*f.h.width*f.h.height)%8UL);
	    offset = (unsigned long)(x+y*f.h.width+(unsigned long)c_char*f.h.width*f.h.height)/8UL;
	    f.character[offset] |= bit_mask;
	  }
	  else if(f.h.bits_per_pixel == 8) {
	    offset = (unsigned long)c_char*(unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8+y*f.h.width+x;
	    f.character[offset] = forecolor;
	  }
	}
	finished = 1;
	font.Create(&f);
      }
      else if(curs_x >= 229 && curs_x < 320) {
	if(curs_y >= 0 && curs_y < 10)
	  ch = '-';
	else if(curs_y >= 10 && curs_y < 20)
	  ch = '+';
	else if(curs_y >= 20 && curs_y < 30)
	  ch = 's';
	else if(curs_y >= 30 && curs_y < 40)
	  ch = 'l';
	else if(curs_y >= 40 && curs_y < 50)
	  ch = 'd';
	else if(curs_y >= 50 && curs_y < 60)
	  ch = 'f';
	else if(curs_y >= 60 && curs_y < 70)
	  ch = 'n';
	else if(curs_y >= 70 && curs_y <= 80)
	  ch = 'q';
      }
      else if(curs_x >= 147 && curs_x <= 227 && curs_y >= 1 && curs_y <= 81) {
	forecolor = (curs_x-147)/5+(curs_y-1)/5*16;
	finished = 1;
      }
    }
    else if(b2) {
      if(!(curs_x >= 0 && curs_x < 146 && curs_y >= 0 && curs_y < 146))
	while(b2)
	  Mouse_Pos();

      if(curs_x >= 1 && curs_x < f.h.width*3+1 && curs_y >= 1 && curs_y < f.h.height*3+1)
	finished = 1;

      if(curs_x >= 0 && curs_x < f.h.width*3+1 && curs_y >= 0 && curs_y < f.h.height*3+1 && (last_time_x != (curs_x-1)/3 || last_time_y != (curs_y-1)/3)) {
	last_time_x = (curs_x-1)/3;
	last_time_y = (curs_y-1)/3;
	if(((curs_y-1)/3) < f.h.height && ((curs_x-1)/3) < f.h.width) {
	  int x = (curs_x-1)/3, y = (curs_y-1)/3;
	  unsigned long offset;
	  if(f.h.bits_per_pixel == 1) {
	    unsigned char bit_mask = 0x80>>((x+y*f.h.width+c_char*f.h.width*f.h.height)%8UL);
	    offset = (unsigned long)(x+y*f.h.width+(unsigned long)c_char*f.h.width*f.h.height)/8UL;
	    f.character[offset] &= ~bit_mask;
	  }
	  else if(f.h.bits_per_pixel == 8) {
	    offset = c_char*(unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8+y*f.h.width+x;
	    f.character[offset] = backcolor;
	  }
	}
	finished = 1;
	font.Create(&f);
      }
      else if(curs_x >= 147 && curs_x <= 227 && curs_y >= 1 && curs_y <= 81) {
	backcolor = (curs_x-147)/5+(curs_y-1)/5*16;
	finished = 1;
      }
    }

    RGB_color color;
    switch(ch) {
      case 0:   switch(getch()) {
		  case 59:  Help_Screen();
			    finished = 1;
			    break;
		  case 71:  Get_Palette_Register(forecolor, &color);
			    color.red+=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		  case 79:  Get_Palette_Register(forecolor, &color);
			    color.red-=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		  case 72:  Get_Palette_Register(forecolor, &color);
			    color.green+=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		  case 80:  Get_Palette_Register(forecolor, &color);
			    color.green-=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		  case 73:  Get_Palette_Register(forecolor, &color);
			    color.blue+=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		  case 81:  Get_Palette_Register(forecolor, &color);
			    color.blue-=4;
			    Set_Palette_Register(forecolor, &color);
			    ofc++;
			    finished = 1;
			    break;
		}
		break;
      case '_': case '-':
		if(c_char > 0) c_char--;
		else c_char = f.h.character_num-1;
		finished = 1;
		break;
      case '+': case '=':
		if(c_char < f.h.character_num-1) c_char++;
		else c_char = 0;
		finished = 1;
		break;
      case ']': if(forecolor < 255) forecolor++;
		else forecolor = 0;
		finished = 1;
		break;
      case '[': if(forecolor > 0) forecolor--;
		else forecolor = 255;
		finished = 1;
		break;
      case '}': forecolor = (forecolor+16)%256;
		finished = 1;
		break;
      case '{': if(forecolor > 15) forecolor -= 16;
		else forecolor += 240;
		finished = 1;
		break;
      case '.': if(backcolor < 255) backcolor++;
		else backcolor = 0;
		finished = 1;
		break;
      case ',': if(backcolor > 0) backcolor--;
		else backcolor = 255;
		finished = 1;
		break;
      case '>': backcolor = (backcolor+16)%256;
		finished = 1;
		break;
      case '<': if(backcolor > 15) backcolor -= 16;
		else backcolor += 240;
		finished = 1;
		break;
      case '7': Get_Palette_Register(forecolor, &color);
		color.red++;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case '1': Get_Palette_Register(forecolor, &color);
		color.red--;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case '8': Get_Palette_Register(forecolor, &color);
		color.green++;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case '2': Get_Palette_Register(forecolor, &color);
		color.green--;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case '9': Get_Palette_Register(forecolor, &color);
		color.blue++;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case '3': Get_Palette_Register(forecolor, &color);
		color.blue--;
		Set_Palette_Register(forecolor, &color);
		ofc++;
		finished = 1;
		break;
      case 'H': case 'h': case '/': case '?':
		Help_Screen();
		FINISHIT
		break;
      case 'S': case 's':
		Save_Font();
		FINISHIT
		break;
      case 'L': case 'l':
		Load_Font();
		FINISHIT
		break;
      case 'R': case 'r':		//Reset Palette
		SetMode(0x3);
		SetMode(0x13);
		FINISHIT
		break;
      case 'P': case 'p':
		SetMode(0x3);
		pcx_picture image;
		PCX_Init(&image);
		printf("Enter name of PCX to load:  ");
		char buf[31];
		gets(buf);
		SetMode(0x13);
		PCX_Load(buf, &image, 1);
		PCX_Delete(&image);
		FINISHIT
		break;
      case 'D': case 'd':
		Save_Palette(pal);
		SetMode(0x3);
		printf("Enter bits per pixel:  ");
		scanf("%d", &f.h.bits_per_pixel);
		printf("Set spacing option: \
			\n 0. Monospaced \
			\n 1. Mono_Script \
			\n 2. Script \
			\n 3. Normal_Space \
			\n 4. Font_Defined_Space \
			\nChoose:  ");
		int t_space;
		scanf("%d", &t_space);
		SetMode(0x13);
		Restore_Palette(pal);
		font.Load(BIOS, f.h.bits_per_pixel, forecolor | backcolor<<8);
		Delete_Temp_Font(&f);
		font.Retrieve(&f);
		f.s.space = t_space;
		if(f.s.space == 4) {
		  f.s.space_string = (char far *)farmalloc(f.h.character_num);
		  for(int i = 0; i < f.h.character_num; i++)
		    f.s.space_string[i] = f.h.width;
		}
		else
		  f.s.space_string = NULL;
		font.Create(&f);
		character_size = (unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
		c_char = 0;
		gets(buf);
		FINISHIT
		break;
      case 'F': case 'f':
		Get_Character_From();
		FINISHIT
		break;
      case 'N': case 'n':
		Create_New_Font();
		gets(buf);
		FINISHIT
		break;
      case 'T': case 't':
		Test_String();
		FINISHIT
		break;
      case 'G': case 'g':
		Save_Palette(pal);
		SetMode(0x3);
		printf("Enter character number:  ");
		int num;
		scanf("%d", &num);
		gets(buf);
		if(num < f.h.character_num && num >= 0)
		  c_char = num;
		else
		  c_char = 0;
		SetMode(0x13);
		Restore_Palette(pal);
		FINISHIT
                break;
      case 'Q': case 'q':
		done = 1;
		finished = 1;
		break;
    }
  }
  if(redraw != -1)
    redraw = 1;
  else redraw = 0;
}

void Conclusion()
{
  FILE *fp;
  textattr(WHITE | (BLUE<<4));
  clrscr();
  if(!(fp = fopen("conclude.txt", "rt"))) {
    printf("FILE CONCLUDE.TXT missing, but\n");
    printf("Register this game anyway!  See ORDER.DOC.\n");
    return;
  }

  while(!feof(fp)) {
    char ch = fgetc(fp);
    if(ch != '\n')
      printf("%c", ch);
  }
}

main()
{
  Introduction();
  font.Retrieve(&f);
  character_size = (unsigned int)f.h.height*(unsigned int)f.h.width*(unsigned int)f.h.bits_per_pixel/8;
  font.Set_Clear(0);
  bios.Set_Clear(0);

  SetMode(0x13);
  Put_Cursor_Buf(curs_x, curs_y);

  while(!done) {
    Put_Cursor_BBuf(curs_x, curs_y);
    Draw_Screen();
    Put_Cursor_Buf(curs_x, curs_y);
    Get_Task();
  }

  SetMode(0x3);

  Conclusion();
  return 0;
}