// GRAPH13H.H
// MODE 13H Graphic Function

#ifndef __RGBCOLOR

#define __RGBCOLOR

typedef struct {
                char red;
                char green;
                char blue;
               } RGB_color;

#endif

/* Colors for setpalette */

#if	!defined(__COLORS)
#define __COLORS

enum COLORS {
    BLACK,		    /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,		    /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};
#endif

#define MODE_13H           0x0013
#define TEXT_MODE          0x0003
#define DEFAULT_FONT       (char far *)0xF000FA6E

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned char Curcol;
extern char far *CurFont;
extern RGB_color def_palette[256];

extern void Draw_rect(unsigned, unsigned, unsigned, unsigned);

extern void Draw_box(unsigned, unsigned, unsigned, unsigned);

extern void OutChar(unsigned, unsigned, unsigned char);

extern void OutText(unsigned, unsigned, char *);

extern void put_pixel(unsigned, unsigned);

extern void clear_video(unsigned);

extern void set_video(unsigned);

extern void set_palette(RGB_color *);

extern void save_area(unsigned, unsigned, unsigned, unsigned, char far *);

extern void put_area(unsigned, unsigned, char far *);

#ifdef __cplusplus
}
#endif
