	page	,132
	title	calendar routines and command line interface
;
;Copyright (c) Wally Bass, 1986, 1996.
;
s	segment
	assume	cs:s
	org	100h
;
UKTRANS = 0	;set to 1 to use U.K. Transition date
DO4K = 0	;set to 1 to alter algorithm to delete a leap year day
		;once every 4000 years in Gregorian period
;
start:	jmp	doit
;
include jdatealg.inc
;
t = (offset start+2560-$) mod 16
IF t
	db	t dup(0)
endIF
	assume	ds:s,es:s,ss:s
;
IF UKTRANS
;
;September 3/14, 1752 transition, as in the U.K. and Colonies
trans	dd	2361222
else
;
;October 5/15, 1582 transition, as in Rome
trans	dd	2299161
endIF
oradix	dw	10	;radix for number conversion on output
pmpfx	db	0	;'+' or '-' prefix seen on difference arg
;
dateinf struc
jdate	dd	?	;julian date
day	db	?	;day
month	db	?	;month
year	dw	?	;year. A zero value indicates invalid date
doy	dw	?	;day of year
dow	db	?	;day of week
	db	?
dateinf ends
;
hlpmsg	db	'Usage:',13,10
 db '  jdate [/|-]?|h  (requests help text)',13,10
 db '  jdate J          or  jdate M D [-]Y  (defines 1 date)',13,10
 db '  jdate J +N2|-N2  or  jdate M D [-]Y +N2|-N2',13,10
 db '                   or  jdate M D [-]Y'
 db ' M2 D2 [-]Y2  (defines 2 dates)',13,10
 db 'where arguments are in decimal or hex(0X...), and',13,10
 db '  J     is a Julian date',13,10
 db '  M D Y are month (1-12), day (1-31'
 db '), and year (-4713 to -1, 1-32767)',13,10
 db '  N     is a day difference count',13,10,10
 db "For invalid arguments, sends 'bad arguments' to stdout,",13,10
 db 'otherwise, for each date, sends to stdout',13,10
 db '  J JH W WS YD M MS D Y  (date valid), or',13,10
 db '  J JH invalid date      (date invalid or J>13689325)',13,10
 db 'and, if two dates are defined',13,10
 db '  N days difference',13,10
 db 'where',13,10
 db '  J and JH  are julian dates (decimal & hex)',13,10
 db "  W and WS  are day of week (0-6 & 'Sun'-'Sat')",13,10
 db '  YD        is day of year (1-366)',13,10
 db "  M and MS  are month (1-12 & 'Jan'-'Dec')",13,10
 db '  D and Y   are day (1-31) and year (-4713 to 32767)',13,10
 db '  N         is a difference count.',13,10
hlpmsgl = $-hlpmsg
argmsg	db	'bad arguments ',13,10
argmsgl = $-argmsg
datemsg db	'invalid date ',13,10
datemsgl = $-datemsg
daymsg	db	' days difference ',13,10
daymsgl = $-daymsg
boiler	db	' 0x       - ',13,10
dowtbl	db	'SunMonTueWedThuFriSat'
motbl	db	'JanFebMarAprMayJunJulAugSepOctNovDec'
;
;'blnkskp' advance SI to next non-whitespace, returns the next 2 chars
;in AL and AH
;
blnkskp proc	near
	lodsw
	dec	si
	cmp	al,' '
	je	blnkskp
	cmp	al,9		;tab
	je	blnkskp
	dec	si
	ret
blnkskp endp
;
;'chkhlp' returns Z if AL is '?', 'h', or 'H'
;
chkhlp	proc	near
	cmp	al,'?'
	je	chret
	cmp	al,'h'
	je	chret
	cmp	al,'H'
chret:	ret
chkhlp	endp
;
;'parsenum' scans a hex or decimal number pointed to by DS:SI
;out:	DX:CX: value of number scanned
;	carry if no number found or overflow
;	BH: 0
;	BL: 10 if decimal number 16 if hex number
;	AX: destroyed
;	SI: advanced to first char not used
;
parsenum proc	near
	xor	dx,dx
	xor	cx,cx
	mov	bx,256+16	;radix 16
	lodsw
	or	ah,20h		;AH to lower case
	cmp	ax,'x0' 	;check for '0x' or '0X' hex prefix
	je	pars06		;jump if hex
	dec	si		;back up one (wasn't '0x')
	mov	bl,10		;radix 10
	jmp	short pars08
;
pars02: shr	bh,1
	push	ax	;save scanned char
	xchg	ax,dx	;AX=high order multiplicand
	mul	bx	;multiply high part
	jc	pars04
	xchg	ax,cx	;CX=high order partial result
			;AX=low order multiplicand
	mul	bx	;multiply
	add	dx,cx	;add in partial high order result
pars04: pop	cx	;restore scanned char
	jc	pars10
	xor	ch,ch
	add	cx,ax
	adc	dx,0
	jc	pars10
pars06: lodsb
	cmp	bl,10		;check if processing decimal number
	je	pars08		;jump if so
;hex number
	mov	ah,20h
	or	ah,al		;AH=lower case of AL
	cmp	ah,'g'
	jnb	pars08		;not A-F or a-f, chk for digit
	cmp	ah,'a'
	jb	pars08		;not A-F or a-f, chk for digit
	mov	al,ah
	sub	al,'a'-0Ah	;map 'a'-'f' to 0Ah-0Fh
	jmp	short pars02
;
pars08: add	al,255-'9'	;map '9' to 255
	sub	al,255-9	;map 255 to 9, borrow if not digit
	jnb	pars02		;jump if valid digit
	dec	si		;prepare to rescan
	shr	bh,1		;carry if error (no digits processed)
pars10: ret
parsenum endp
;
;'chkval sets carry unless DX is zero and CX is below AX
;
chkval	proc	near
	cmp	dx,1
	jnb	chkv02
	cmp	cx,ax
chkv02: cmc
	ret
chkval	endp
;
;'putjul', 'putnum', and 'putnuml' convert the number in ss:[bp].jdate
;(putjul) or AX (putnum) or DX:AX (putnuml) to a string of digits, which
;is outputted at ES:DI. The radix for the conversion is in oradix. One
;additional byte pointed to by DS:SI is appended to the output.
;AX is destroyed, SI and DI are advanced, BX, CX, and DX are zeroed
;
putjul	proc	near
	mov	ax,word ptr ss:[bp].jdate
	mov	dx,word ptr ss:[bp].jdate+2
	jmp	short putnuml
;
putnum	proc	near
	xor	dx,dx
;
putnuml proc	near
	xor	cx,cx
divloop:xchg	ax,bx	;BX=low dividend 'digit'
	xchg	ax,dx	;AX=high dividend 'digit' to AX
	xor	dx,dx
	div	oradix	;AX=high quotient 'digit',DX=remainder
	xchg	ax,bx	;BX=high quotient 'digit'
			;DX:AX=next 'trial' dividend
	div	oradix	;AX\second quotient 'digit',DX=remainder
	xchg	bx,dx	;BX=remainder
			;DX=high quotient 'digit'
	inc	cx
	cmp	bl,10
	jb	nothex
	add	bl,7
nothex: add	bl,'0'
	push	bx
	mov	bx,ax
	or	bx,dx
	jnz	divloop
outloop:pop	ax
	stosb
	loop	outloop
	movsb
	ret
putnuml endp
putnum	endp
putjul	endp
;
;'mov3b' moves three byte from location DS:[AX+3*BX] to the ES:DI
;stream, followed by one byte from the DS:SI stream
;AX is destroyed, SI and DI are advanced.
;
mov3b	proc	near
	add	ax,bx
	add	ax,bx
	add	ax,bx
	xchg	ax,si
	movsw
	movsb
	xchg	ax,si
	movsb
	ret
mov3b	endp
;
;'collect' parses a date argument pointed to by DS:SI, fills in the
;dateinf structure pointed to by BP, places output text in the buffer
;specified by ES:DI, and sets the following return codes:
;  below	bad argument
;  equal	julian argument
;  above	m d y argument or +N|-N argument
;In:  DS:SI: date argument input
;     pmpfx: '+' or '-' if difference arg, 0 otherwise
;     BP: locates dateinf struc to be filled in
;     ES:DI: output string location
;Out: carry if invalid argument, otherwise
;     BP->dateinf struc: filled in
;     ES:DI-> output data
;     SI, DI: advanced
;     AX,DX: destroyed
;     BX,CX: 0
;
collect proc	near
	call	parsenum
	jc	error
	call	blnkskp
	xor	bx,bx
	mov	ss:[bp].year,bx
	cmp	pmpfx,bl
	je	nopmpfx
	cmp	pmpfx,'-'
	jne	plusdt
	neg	dx
	neg	cx
	sbb	dx,bx
plusdt: add	cx,word ptr data1.jdate
	adc	dx,word ptr data1.jdate+2
	test	bp,bp		;indicate +N|-N argument
	jmp	short jjoin
nopmpfx:cmp	al,'+'
	je	isjul
	cmp	al,'-'
	je	isjul
	cmp	al,0
	jne	isdate		;jump if more args
;julian date input. check for excess value
isjul:	cmp	ax,ax		;indicate julian argument (equal)
jjoin:	pushf
	xchg	ax,cx
	mov	word ptr ss:[bp].jdate,ax
	mov	word ptr ss:[bp].jdate+2,dx
	cmp	ax,0E1EEh
	push	dx
	sbb	dx,0D0h
	pop	dx
	push	si
	push	di
	jnb	output1
;arg in range, compute calendar date
	mov	si,word ptr trans
	mov	di,word ptr trans+2
	call	fromjul
	mov	ch,al
	mov	word ptr ss:[bp].day,cx
	mov	ss:[bp].year,si
output1:jmp	short output
;
;something follows first numeric arg, must be calendar date
;
isdate: mov	ax,12
	mov	ss:[bp].month,cl
	dec	cx
	call	chkval	;check for month in range
	jc	error
	call	parsenum	;parse next arg
	jc	error
	mov	ax,31
	mov	ss:[bp].day,cl
	dec	cx
	call	chkval	;check for day in range
	jnc	noerror
error:	ret
;
noerror:call	blnkskp
	cmp	al,'-'	;check for negative year
	push	ax
	jne	m06
	inc	si	;skip sign if present
m06:	call	parsenum	;parse next arg
	pop	ax
	jc	error
	cmp	al,'-'
	jne	notbc
	mov	ax,4713+1
	call	chkval	;check year in range, B.C.
	jc	error
	neg	cx	;make negative
	jmp	short isbc
notbc:	mov	ax,32768
	call	chkval	;check year in range, A.D.
	jc	error
isbc:	mov	ss:[bp].year,cx
	call	blnkskp
;
	test	bp,bp	;set not-zero
	pushf
	push	si
	push	di
	xchg	ax,cx
	mov	cx,word ptr ss:[bp].day
	mov	si,word ptr trans
	mov	di,word ptr trans+2
	push	di
	push	si
	call	tojul	;get julian date
	pop	si
	pop	di
	mov	word ptr ss:[bp].jdate,ax
	mov	word ptr ss:[bp].jdate+2,dx
	call	fromjul ;get calendar date from julian
	mov	ch,al
	cmp	si,ss:[bp].year
	jne	baddate ;invalid date if inverse map differs
	cmp	cx,word ptr ss:[bp].day
	je	output
baddate:mov	ss:[bp].year,0
output: cmp	ss:[bp].year,0	;year=0 signals invalid date
	je	invdate
	mov	ax,word ptr ss:[bp].jdate
	mov	dx,word ptr ss:[bp].jdate+2
	call	dayofwk 	;compute day of week
	mov	ss:[bp].dow,dl
	mov	ax,ss:[bp].year
	mov	cx,101h 	;1st day of year
	mov	si,word ptr trans
	mov	di,word ptr trans+2
	call	tojul		;compute julian for 1st of year
	neg	ax
	add	ax,word ptr ss:[bp].jdate
	inc	ax		;compute day in year
	mov	ss:[bp].doy,ax
invdate:pop	di
	mov	si,offset boiler	;boilerplate string
	call	putjul		;put julian date in decimal
	movsw			;put hex prefix
	mov	byte ptr oradix,16
	call	putjul		;put julian date in hex, set BX=0
	mov	byte ptr oradix,10
	cmp	ss:[bp].year,bx ;check year for zero
	jne	gooddate	;jump if valid date
	mov	si,offset datemsg
	mov	cx,datemsgl
	rep	movsb		;put invalid date message, set CX=0
	jmp	short linedone
;
gooddate:mov	al,ss:[bp].dow
	cbw
	push	ax
	call	putnum		;put day of week as number
	pop	bx
	mov	ax,offset dowtbl
	call	mov3b		;put day of week as string
	mov	ax,ss:[bp].doy
	call	putnum		;put day of year
	mov	al,ss:[bp].month
	cbw
	push	ax
	call	putnum		;put month as number
	pop	bx
	mov	ax,offset motbl-3
	call	mov3b		;put month as string
	xchg	ax,bx		;clear AH
	mov	al,ss:[bp].day
	call	putnum		;put day of month
	mov	ax,ss:[bp].year
	inc	si
	test	ax,ax
	jns	notneg
	dec	si
	movsb			;put '-' for neg year
	neg	ax
notneg: call	putnum		;put year, returns BX=0,CX=0
	movsw		;CR-LF
linedone:pop	si
	popf
	ret
collect endp
;
;start here
;
doit:	cld
	mov	si,81h
	xor	bx,bx
	mov	bl,ds:[si-1]
	mov	ds:[si+bx],bh	;nul terminate the argument
	call	blnkskp
	xchg	al,ah
	call	chkhlp		;check for help request
	xchg	al,ah
	jne	m02
	cmp	al,'/'
	je	dohelp
	cmp	al,'-'
	je	dohelp
m02:	call	chkhlp		;check for help request
	jne	nothelp
	and	ah,not 20h
	jnz	nothelp
;
;put help text to std err
;
dohelp: mov	cx,hlpmsgl
	mov	dx,offset hlpmsg
	mov	bx,2	;to std err
	mov	al,3	;return code
	push	ax
	jmp	short write
;
badarg: mov	cx,argmsgl
	mov	dx,offset argmsg
	jmp	short stdout
;
nothelp:mov	bp,offset data1
	mov	di,offset outbuff
	call	collect
	jc	badarg
	mov	al,ds:[si]
	cmp	al,0
	je	onedate
	mov	bp,offset data2
	cmp	al,'-'
	je	ispm
	cmp	al,'+'
	jne	notpm
ispm:	mov	pmpfx,al
	inc	si
	call	blnkskp
notpm:	call	collect 	;returns BX=0,CX=0 if no carry
	jbe	badarg
	cmp	byte ptr ds:[si],cl
	jne	badarg
	mov	ax,word ptr ss:[bp].jdate
	mov	dx,word ptr ss:[bp].jdate+2
	sub	ax,word ptr ss:[bp].jdate-type dateinf
	sbb	dx,word ptr ss:[bp].jdate+2-type dateinf
	jnb	isplus
	neg	dx
	neg	ax
	sbb	dx,cx
isplus: call	putnuml
	dec	di
	mov	si,offset daymsg
	mov	cx,daymsgl
	rep	movsb
onedate:mov	cx,di
	mov	dx,offset outbuff
	sub	cx,dx
stdout: mov	bx,1
write:	mov	ah,40h
	int	21h
	xchg	ax,bx
	dec	ax
	mov	ah,4Ch
	int	21h
;increase load module to multiple of sector size for faster loading
t = (offset start+5120-$) mod 512
IF t
	db	t dup(0)
endIF
data1	equ	this byte
data2	equ	data1+type dateinf
outbuff equ	data2+type dateinf
s	ends
	end	start
