/* Copyright (c) Wally Bass, 1986, 1996. */

/* #define DO4K */

static char cw[]="(c)Wally Bass 1986,1996";

/*use the second typedef here for 'ewv' ('efficient work variable') if
  the target machine is less comfortable with 16 bit operations than it
  is with 32 bit operations*/

typedef unsigned short ewv;
/* typedef long ewv; */

int dayofwk(j) /* returns 0 thru 6 = Sun thru Sat */
  long j;
{
  return (j+1)%7;
}

long tojul(jt,m,d,y) /*returns Julian date*/
  long jt;		/* transition date as a Julian date */
  unsigned char m,d;	/* month (1-12), day (1-31) */
  short y;		/* year (-4713 to 32767) */
{
  long j;		/* calculate output here */
  ewv uy;		/* year+4900 */
  uy=(y+(y<0))+(ewv)4900;
  if (m<3) {
      uy-=1;
      m+=12;
    }
  j=((uy*1461L)/4)+(((ewv)(m+1)*(ewv)153)/(ewv)5)+d-68730;
  if (j>jt) {
      j-=(((uy/(ewv)100)*(ewv)3)/(ewv)4)
#ifdef DO4K
         +(uy-(ewv)4900)/(ewv)4000
#endif
         -38;
    }
  return j;
}

void fromjul(jt,j,mout,dout,yout)
  long jt;		/* transition date as a Julian date (input) */
  long j;		/* Julian date to convert (input) */
  unsigned char *mout,*dout; /* month, day (output) */
  short *yout;		/* year (output) */
{
  unsigned short m;	/* build output month here */
  short y;		/* build output year here */
  register ewv t;	/* general purpose temp */
#ifdef DO4K
  long tj;		/* temp */
#endif
  t=(j<jt);
  j+=68730L;
  if (!t) {
#ifdef DO4K
      tj=j-(68730L+1721120L);
      while ((tj-=1460969L)>=0) j+=1;	/* iterations=y/4000, 8 max */
#endif
      /* 48699*3 = 146097 = 365*400+97 = number of days in 400 years */
      t=((j*4)-643)/48699; /*either 643 or 644 works okay here*/
      j+=(((t/(ewv)3)*(ewv)3)/(ewv)4)-38;
    }
  t=((j*4)-489)/1461;
  y=t-4900;
  t=j-((t*1461L)/4);
  m=((t*(ewv)5)-(ewv)1)/(ewv)153;
  *dout=t-((m*(ewv)153)/(ewv)5);
  if (--m>12) {
      y+=1;
      m-=12;
    }
  *mout=m; *yout=y-(y<=0);
}
