#ifndef __JGMATCH_H
#define __JGMATCH_H

#include "vector.h"
#include "bstring.h"

/* This class was written by Jeff Goke.  However, it is a *very* close
   version of a similar class present by Timothy Budd's outstanding text
   Classic Data Structures in C++.  This class uses a loose version of
   the Boyer-Moore pattern search technique. */

class jgmatch
	{
	public:

	jgmatch (const bstring & pat, const bstring & text);
	~jgmatch ();

	is_match ();
		// returns one if match, returns zero if isn't.

	private:

	const bstring & text;
	const bstring & pattern;

	vector<int>	num_array;
	};

#endif /* __JGMATCH_H */