; This routine is part of VESA SVGA -library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

model large,c
p386

include "jlvesads.asm"

segment jlvesa15_TEXT USE16 'CODE'
assume cs:jlvesa15_TEXT

; This routine positions read window to EDX. Registers do not change.
; DS must point to JLVesa_Data!

proc vesa_repos_r far
   public vesa_repos_r

   ; Reposition active drawing window (read)

   ; Calculate new address for window

   push  eax
   push  ebx
   push  ds
   mov   ax,JLVesa_Data
   mov   ds,ax
reposition:
   mov   eax,edx              ; Calculate address in granularity units
   mov   ebx,[ds:Granularity]
   push  edx
   xor   edx,edx
   div   ebx

   mov   dx,ax                ; Set new window address
   xor   bh,bh
   mov   bl,[ds:RWin]
   push  eax
   call  [ds:PosFunc]
   pop   eax

   mov   ebx,[ds:Granularity] ; Calculate absolute address of new window
   mul   ebx
   pop   edx

   mov   bl,[ds:WWin]         ; Check if both windows have to be updated
   cmp   [ds:RWin],bl
   jne   short different_windows

   mov   [ds:WAStart],eax     ; Update also address of read window if necessary

different_windows:
   mov   [ds:RAStart],eax     ; Update address of write window
   pop   ds
   pop   ebx
   pop   eax
   retf                       ; Return to main routine

endp vesa_repos_r

ends

end
