; This file is part of JLVESA-library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

model large,c
p386

include "jlvesads.asm"

segment jlvesa18_TEXT USE16 'CODE'
assume cs:jlvesa18_TEXT

; int JVScreen_SetLogicalWidth(JVUWord lwidth)
;
; Sets logical scan line width. Returns scan line length after set. If desirable
; width is not achievable, next larger width will be used. Returns 0 if function
; is not supported!

proc JVScreen_SetLogicalWidth far
   public JVScreen_SetLogicalWidth

   push  bp
   mov   bp,sp
   push  ds

   ; Set DS to point to data segment

   mov   ax,JLVesa_Data
   mov   ds,ax

   ; Call logical width set routine

   mov   ax,4f06H
   mov   bl,0
   mov   cx,[ss:bp+6]
   int   10H

   ; Check if function supported

   cmp   al,4fH
   jne   short not_supported

   ; Return with new width

   mov   [ds:LWidth],cx
   mov   ax,cx
   pop   ds
   pop   bp
   retf

   ; Return 0 if not supported

not_supported:
   pop   ds
   pop   bp
   xor   ax,ax
   retf

endp JVScreen_SetLogicalWidth

ends

end
