/**
 ** sipp - SImple Polygon Processor
 **
 **  A general 3d graphic package
 **
 **  Copyright Jonas Yngvesson  (jonas-y@isy.liu.se) 1988/89/90/91
 **            Inge Wallin      (ingwa@isy.liu.se)         1990/91
 **
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 1, or any later version.
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 ** You can receive a copy of the GNU General Public License from the
 ** Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 **/

/**
 ** objects.h - Types and interface to objects.c
 **/

#ifndef OBJECT_H
#define OBJECT_H

#include <sipp.h>


/*
 * Objects installed in the database for rendering are kept
 * in a binary tree, internal to sipp. This database will
 * automatically contain all top level objects, but the user
 * can also force objects in or out of it.
 */
typedef struct inst_obj_t {
    Object *object;
    struct inst_obj_t *big;
    struct inst_obj_t *sml;
} Inst_object;


extern Inst_object         *object_db;       /* Object database. */


extern void   objects_init();


#endif /* OBJECT_H */
