/**
 ** sipp - SImple Polygon Processor
 **
 **  A general 3d graphic package
 **
 **  Copyright Jonas Yngvesson  (jonas-y@isy.liu.se) 1988/89/90/91
 **            Inge Wallin      (ingwa@isy.liu.se)         1990/91
 **
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 1, or any later version.
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 ** You can receive a copy of the GNU General Public License from the
 ** Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 **/

/**
 ** smalloc.c - "Safe" malloc and calloc.
 **/

#include <malloc.h>
#include <stdio.h>


char *
smalloc(size)
    int size;
{
    char *p;

    p = (char *)malloc(size);
    if (p == NULL) {
        fprintf(stderr, "smalloc(): Out of memory.\n");
        exit(1);
    }

    return p;
}


char *
scalloc(size, itemsize)
    int size;
    int itemsize;
{
    char *p;

    p = (char *)calloc(size, itemsize);
    if (p == NULL) {
        fprintf(stderr, "scalloc(): Out of memory.\n");
        exit(1);
    }

    return p;
}



