/* $Revision: 1.5 $ */
/*
 EPSHeader

   File: log.h
   Author: J. Kercheval
   Created: Sat, 06/08/1991  09:25:44
*/

/*----------------------------------------------------------------------------
*
*  log_open() opens the log file for writing after closing the log file if
*       already opened.  The BOOLEAN parameter to_stderr is true if stderr
*       is to be used for logging.  The BOOLEAN parameter overwrite is true
*       the current file for logging is to be overwritten.
*  log_close() closes an opened log file
*  log_message() sends message to stdout and to log file if open
*
----------------------------------------------------------------------------*/

BOOLEAN log_open(char *fname, BOOLEAN to_stderr, BOOLEAN overwrite);
void log_close(void);
void log_message(char *message);
void log_error(char *message);
void log_info(char *message);
void log_flags(Flags *flags);
void log_stdout(char *message);


/*----------------------------------------------------------------------------
 *
 * tpwrite(), tfprintf() and tfclose checks the output stream for
 * output errors caused by disk space full conditions.
 *
 ---------------------------------------------------------------------------*/

void __cdecl tfwrite(const void *buf, size_t size, size_t count, FILE *fp);
void __cdecl tfprintf(FILE *fp, char *fmt, ...);
void __cdecl tfclose(FILE *fp);
