// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "win95dlg.h"    
#include "dadlg.h"  
#include "cvtname.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_OPENFILEWIN95DIALOG, OnFileOpenFileWin95Dialog)
	ON_COMMAND(ID_FILE_SAVEASFILEWIN95DIALOG, OnFileSaveAsFileWin95Dialog)
	ON_COMMAND(ID_FILE_CONVERTLONGFILENAMETOSHORTFILENAME, OnFileConvertlongfilenametoshortfilename)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}
      
      
    DragAcceptFiles();
    
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnFileOpenFileWin95Dialog()
{
	CreateWin95FileDlg(TRUE, // TRUE if File Open, otherwise FALSE
	                   "xxx", // default extension 
	                   "Bogus File Name.xxx", // initial filename that appears in the filename edit box. If NULL, no filename initially appears
	                   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, // file open flags 
	                                                           // see the OPENFILENAME structure description in the Windows SDK documentation
					   "Bogus Files (*.xxx) | *.xxx|All Files (*.*) | *.*||||", // A series of string pairs that specify filters you can apply to the file
	                   m_hWnd); // handle to the file dialog-box object's parent or owner window

    SetWin95DlgTitle("Open a Bogus File");
    
    if ( Win95DlgDoModal(m_hWnd) == IDOK )
    	{
	    char lpszLongName[256];
	    char lpszShortName[256]; 
	    
	    GetWin95FilePath(lpszShortName, sizeof(lpszShortName));
	    GetWin95LongFilePath(lpszLongName, sizeof(lpszLongName));
	    
	    CString str("The Windows 95 long file name is:\n\n");
	    str += lpszLongName;
	    
	    MessageBox(str);
	    
	    str = "The Windows 95 short file name is:\n\n";
	    str += lpszShortName;
	    
	    MessageBox(str); 
	    }
}

void CMainFrame::OnFileSaveAsFileWin95Dialog()
{
	CreateWin95FileDlg(FALSE, // TRUE if File Open, otherwise FALSE
	                   "xxx", // default extension 
	                   "Bogus File Name.xxx", // initial filename that appears in the filename edit box. If NULL, no filename initially appears
	                   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, // file open flags 
	                                                           // see the OPENFILENAME structure description in the Windows SDK documentation
					   "Bogus Files (*.xxx) | *.xxx|All Files (*.*) | *.*||", // A series of string pairs that specify filters you can apply to the file
	                   m_hWnd); // handle to the file dialog-box object's parent or owner window

    SetWin95DlgTitle("Save a Bogus File");
    
    if ( Win95DlgDoModal(m_hWnd) == IDOK )
		{    
	    char lpszLongName[256];
	    char lpszShortName[256]; 
	    
	    GetWin95FilePath(lpszShortName, sizeof(lpszShortName));
	    GetWin95LongFilePath(lpszLongName, sizeof(lpszLongName));
	    
	    CString str("The Windows 95 long file name is:\n\n");
	    str += lpszLongName;
	    
	    MessageBox(str);
	    
	    str = "The Windows 95 short file name is:\n\n";
	    str += lpszShortName;
	    
	    MessageBox(str);
	    }
}

void CMainFrame::OnFileConvertlongfilenametoshortfilename()
{
	ConvertNameDlg dlg;
	
	dlg.DoModal();
}

void CMainFrame::OnDropFiles(HDROP hDropInfo)
{
	char FileName[256];

	DragQueryFile (hDropInfo, 
				   0, 
				   FileName, 
				   (UINT) sizeof(FileName)); 
				   
	CString str;
	CString strPath(FileName);
	
	int i = strPath.Find ( ".LNK" ) ;
	if ( i == -1 )
		{
		str = "The following file name was dropped:\n\n";
		str += FileName;
		str += "\n\nNext time trying dropping a shortcut file on the window...";
		MessageBox(str);
		return;
		}
	else 
		{
		::ResolvePathName(m_hWnd, FileName, sizeof(FileName));
		
		str = "The following Windows 95 shortcut file\nthat was dropped refers to this file name:\n\n";
		str += FileName;
		MessageBox(str);
		}
}
