/*****************************************************************************
  RATEDLG.H

  Purpose:
  	Interface to CRateDlg, which allows the user to specify how often to
  	update the main dialog display.

  Functions:
	CRateDlg::CRateDlg()            -- constructor
	CRateDlg::DoDataExchange()		-- dialog data exchange/validation  
	CRateDlg::GetRate()				-- retrieve update rate
	CRateDlg::OnInitDialog()		-- initialize dialog

  Development Team:
	Mary Kirtland
  Ported to 32-bit by:
    Mike Hedley	
  Written by Microsoft Product Support Services, Premier ISV Support
  Copyright (c) 1996 Microsoft Corporation. All rights reserved.
\****************************************************************************/

#ifndef __RATEDLG_H__
	#define __RATEDLG_H__
	
class CRateDlg : public CDialog
{
// Construction
public:
	CRateDlg(UINT iRate, CWnd* pParent = NULL);   
	
// Attributes
	UINT GetRate() const { return m_iRate; }	

// Dialog Data           
protected:
	//{{AFX_DATA(CRateDlg)
	enum { IDD = IDD_RATE };
	UINT	m_iRate;
	//}}AFX_DATA


// Overrides
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support  
	virtual BOOL OnInitDialog();

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CRateDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
}; 

#endif //__RATEDLG_H__

