#include <dir.h> // for directory operations //
#include <dirent.h> // for directory operations //
#include <fcntl.h> // for return value of drive ready test //
#include <alloc.h> // for coreleft() memory testing //
#include <ctype.h> // for toupper() //
#include "mhandler.cpp"  // for mouse support //
#include "window.cpp" // for windowing class //
#include "scroll.cpp" // for scrolling screen up and down //
#include "qprintf.cpp" // for quick screen output //

#define NUL '\0' // to null terminate strings //
#define LAST_CHAR(str) (str)[strlen(str) - 1] // to chop a string by one //

void end(void);
void read(void);
void home(void);
int getkey(void);
void search(void);
void page_up(void);
void arrow_up(void);
void new_file(void);
void jump_read(void);
void page_down(void);
void scrollbar(void);
void read_help(void);
int cd(char *cdname);
void arrow_down(void);
void arrow_left(void);
void arrow_right(void);
void show_status(void);
void file_select(void);
void pause_win(char *s);
int error_win(char *msg);
void scroll_show(char *string);
void scroll_select(int numelements);
void show(int x, int y, char *string);
int sort_function( const void *a, const void *b);
void far handler(unsigned deverr, unsigned errval, unsigned far *devhdr);

   FILE *in; // file pointer //
   unsigned long far *loc; // far array of dynamically allocated newline locations //
   long searchloc, saveloc, lineloc; // search position trackers //
   int sortorder=0; // for sorting by name(0), or extension(1) //
   int i, z, bc, fc, cnt, mcnt, col=0, key, save, fail, startcnt, newscan; // control integers //
   int num, searchsuccess, searched, lincount, lastline, maxsize, right, nofile=0, rightarray[25]; // control integers //
   unsigned int ypos; // scroll bar position //
   union REGS regs; // to hold dos function call registers //
   char ch, tmp[3], linecount[25]; // storage for strings //
   char filename[15], searchstring[50], showstring[50]; // storage for strings //
   char **array; // array to store char pointers to filenames //
   // reading window descriptor //
   wintype w1(0, 0, 80, 25, 1, " ESC=Exit      F1=Help  F2=Search  F10=New  Home  End  PgUp  PgDn         ");
   // help window descriptor //
   wintype help(0, 0, 80, 25, 1, "    ESC=Resume                                          READ File Viewer    ");
   // file selector window descriptor //
   wintype scrollwin(31, 2, 49, 22, 1, "");
   // wait window descriptor //
   wintype pause(13, 7, 67, 9, 1, "");

   static char *err_msg[] = // standard error list //
   { "Write protect",    "Unknown unit",
     "Drive not ready",  "Unknown command",
     "Data error (CRC)", "Bad request",
     "Seek error",       "Unknown media type",
     "Sector not found", "Printer out of paper",
     "Write fault",      "Read fault",
     "General failure",  "Reserved",
     "Reserved",         "Invalid disk change"
    };

int getkey(void)
{
   // implement delay rate if button still pressed from last call //
   while(L_DOWN || R_DOWN) // if pressing either button //
   { Mshow(); // keep showing mouse //
     if(mcnt == 350) // 350 ms is a good mouse delay rate //
     break; // break loop //
     delay(1); // delay 1ms for each mcnt while either button is pressed //
     mcnt++; // increment counter //
    }
   // once released reset mcnt to zero //
   if(!L_DOWN && !R_DOWN) // if not pressing either button //
   { mcnt=0; // reset counter if not pressed //
    }
   // begin waiting for mouse press or keyboard hit //
   while(!kbhit()) // while the keyboard is not pressed //
   { Mshow(); // keep showing mouse //
     if(L_DOWN) // if left button pressed //
     { Mhide(); // always hide mouse while screen changes //
       delay(20); // 20ms is very close to most keyboard repeat rates //
       return 999; // return 999, to use as a case in a switch statement. //
      }      // After getkey() funtion returns back to where it came from //
	     // determine action based upon mouse M_xpos and M_ypos locations //
     if(R_DOWN) // if right button pressed //
     { Mhide(); // always hide mouse while screen changes //
       delay(20); // 20ms is very close to most keyboard repeat rates //
       return 1000; // return 1000, to use as case in a switch statement. //
      }      // After getkey() funtion returns back to where it came from //
    }	     // determine action based upon mouse M_xpos and M_ypos locations //
   // if it makes it to here, then the keyboard was just pressed //
   Mhide(); // always hide mouse while screen changes //
   // determine value of the key pressed above //
   switch (key = (int)getch()) // get the key //
   { case 0: return 256 + (int)getch(); // return 256 + extended key value //
     default: return key; // return normal key value //
    }
 }
void read(void) // function to read and display next line from the file //
{
   int l, xl, yl, cc=0; // control integers //

   fseek(in, loc[cnt], SEEK_SET); // seek to correct location for request //
   yl=w1.gety(); // store y window location
   do
   { ch = fgetc(in); // get char from file //
     if(ch == '\n')
     { w1.resetxy();
       cnt++;
       cc=0;
       right=0;
       break;
      }
     if(ch == '\r')
     { continue;
      }
     if(ch == '\t') // if tab //
     { if(cc >= col) // if in viewport area //
       { for(l=1;l<=8;l++) // expand it //
	 { xl=w1.getx(); // get x location for window //
	   qputch(xl+2,yl+2,7,' '); // fast display at correct location //
	   w1.movex(); // update cursor position //
	   cc++; // count spaces //
	  }
	}
       else // if not in viewport area //
       { for(l=1;l<=8;l++)
	 { cc++; // just count the spaces //
	  }
	}
      }
     else // skip returns, newlines and tabs and non-ascii //
     { if(cc >= col) // if in viewport area //
       { xl=w1.getx(); // get x location //
	 if(searchsuccess==1)
	 { if(ftell(in) >= searchloc && ftell(in) <= searchloc+strlen(searchstring)-1)
	   { if(vmode==3)
	     qputch(xl+2,yl+2,15+(1<<4),ch); // fast display at correct location //
	     else
	     qputch(xl+2,yl+2,0+(7<<4),ch); // fast display at correct location //
	    }
	   else
	   qputch(xl+2,yl+2,7,ch); // fast display at correct location //
	  }
	 else
	 qputch(xl+2,yl+2,7,ch); // fast display at correct location //
	 w1.movex(); // update cursor position //
	}
       cc++;
      }
     if(w1.getx() == 78) // if right margin //
     { w1.resetxy(); // return to left margin //
       cnt++; // advance linecount //
       right=1; // fill right array with yes //
       return;
      }
    } while(ch != EOF);  // while not done //
   if(ch==EOF && cc==1) // adjust for EOF //
   { cnt++;
    }
 }
void jump_read(void) // jump to dragged scroll bar location and display //
{
   unsigned long x, y; // control integers //

   if(lastline<=23)
   { show_status();
     return;
    }

   x = (ypos * 100) / 23; // percentage of scrollbar //
   y = (x * (unsigned long)lastline) / 100; // line equiv of percentage //

   cnt = startcnt = y; // count = line //

   if(cnt>lastline-23)
   cnt=startcnt=lastline-23;

   w1.wincls();
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
 }
void show(int x, int y, char *string)
{
   w1.setcolor(fc); // set to foreground of border //
   w1.setbkcolor(bc); // set to background of border //
   w1.wcout(x, y, string); // write string //
   w1.setcolor(white); // reset viewport foreground to white //
   w1.setbkcolor(black); // reset viewport background to black //
 }
void scroll_show(char *string)
{
   scrollwin.setcolor(fc); // set to foreground of border //
   scrollwin.setbkcolor(bc); // set to background of border //
   scrollwin << string; // write string //
   scrollwin.setcolor(lightgray); // reset viewport foreground to black //
   scrollwin.setbkcolor(black); // reset viewport background to black //
 }
void pause_win(char *s)
{
   pause.setcolor(white);
   if(vmode==3) pause.setbkcolor(blue); else pause.setbkcolor(black);
   pause.winput(); pause.wincls();
   pause.line_border();
   pause << s;
 }
void show_status(void)
{
   int x; // x location integer //

   show(34,25,"        "); // clear area of lower border //
   sprintf(showstring, "Column:  %d", col); // concatenate column string //
   show(26,25,showstring); // show columns in lower border //
   if(ch==EOF)cnt=lastline; // adjust for EOF //
   sprintf(linecount,"Line:  %d of %d  ", cnt, lastline); // concat status //
   x = (80-strlen(linecount)); // calculate x location for status //
   show(57,25,"                         "); // ensure lower border is clear //
   show(x+1,25,linecount); // show lines in lower border //
   scrollbar(); // display right scrollbar //
 }
void scrollbar(void) // draw right scrollbar and location indicator //
{
   int y; // scroll bar position tracker //
   unsigned long percent; // percentage of file tracker //
   unsigned long x, m, curline, maxline; // used to calculate percentage //

   m = 23; // max scroll bar positions //
   curline = cnt; // save cnt as an unsigned long for later use //
   maxline = lastline; // save lastline as an unsigned long for later use //
   _wscroll=0; // turn off screen scroll for bottom corner arrow //
   for(y=1; y<=25; y++)  // display scroll bar loop //
   { if(y==1) show(80,y,""); // if start of bar than show up arrow //
     else if(y==25) show(80,y,""); // if end of bar than show down arrow //
     else show(80,y,""); // show rest of scroll bar //
    }
  _wscroll=1; // reset screen scroll //
  x = curline * m; // percentage of scroll bar //
  ypos = x / maxline; // calculate new y position //
  if(ypos==0) ypos=1; // if calculation is zero than yposition = 1;
  show(80,ypos+1,""); // display file position indicator //
  percent = (curline * 100) / maxline; // calculate percentage of file //
  show(52,25,"     "); // clear lower border for status //
  sprintf(showstring, "Percent:  %d", percent); // concat percentage //
  show(43,25,showstring); // show percentage in lower border //
 }
void search(void)
{
   int a, count;
   char alpha[3];
   char buffer[255];
   char *found;
   wintype srch(19, 7, 59, 10, 1, "");

   searchsuccess=0;
   if(vmode==3){ srch.setcolor(white); srch.setbkcolor(blue); }
   else { srch.setcolor(black);srch.setbkcolor(lightgray); }
   srch.winput(); srch.line_border();
   srch.wcout(2,1," ESC ");
   srch.wcout(12,1," Enter Text to Find ");
   if(searched==1)
   srch.wcout(9,4," F3 = Repeat Last Search ");
   reenter : srch.wincls();
   _setcursortype(_NORMALCURSOR);
   srch << "\n   ";
   srch.winxy(srch.getx()-36,srch.gety());

   count=0;
   rekey : key = getkey();
   if(key==317 && searched==1)
   goto repeat;
   if(M_ypos==11 && M_xpos >= 29 && M_xpos <= 51 && searched==1)
   goto repeat;
   if((key==27) || (M_ypos==8 && M_xpos>=22 && M_xpos<=24))
   { srch.winremove();
     _setcursortype(_NOCURSOR);
     key=0;
     return;
    }
   if((key=='\r') || (M_ypos==8 && M_xpos>=32 && M_xpos<=49))
   { goto end;
    }
   if(key=='\b')
   { bksp : if(count==0)
     { goto rekey;
      }
     LAST_CHAR(searchstring) = NUL;
     srch.winxy(srch.getx()-1,srch.gety());
     srch << "";
     srch.winxy(srch.getx()-1,srch.gety());
     count--;
     goto rekey;
    }
   if((key < 32) || (key > 126))
   { goto rekey;
    }
   sprintf(alpha,"%c",key);
   srch << alpha;
   if(count==0)
   { strcpy(searchstring, alpha);
    }
   if(count>0)
   { strcat(searchstring, alpha);
    }
   count++;
   if(count==35)
   { do {
     key = getkey();
     } while((key != '\r') && (key != '\b'));
     if(key == '\b')
     { goto bksp;
      }
     else
     { goto end;
      }
    }
   goto rekey;
   end : if(count==0)
	 { goto rekey;
	  }

   // goto next location for search again, or BOF for new search //
   repeat : if(key==317 || key==999) // jump here if repeat srch //
   fseek(in, saveloc, SEEK_SET); // search forward from current loc //
   else
   { rewind(in); // reset to BOF //
     lincount=0;
    }

   // simple text search algorithm //
   while(fgets(buffer, 255, in))
   { lineloc=ftell(in);
     found = strstr(strupr(buffer), strupr(searchstring));
     if(found)
     { searchloc = lineloc - (strlen(buffer)-1) + (found-buffer);
       saveloc = searchloc+strlen(searchstring)-1; // save for next search //
       for(a=0; a<=lastline; a++)
       { if(loc[a] > searchloc) // get end loc of current line //
	 { a--;
	   break;
	  }
	}
       col = searchloc - loc[a] - 35; // always visible //
       if(col<0)col=0;
       searchsuccess=1;
       break;
      }
     lincount++; // track lines for displaying found text //
    }
   _setcursortype(_NOCURSOR);

   // display found text or error msg if not //
   if(searchsuccess==1)
   { srch.winremove();
     w1.wincls();
     cnt=startcnt=lincount-8;
     if(cnt<0)cnt=startcnt=0;
     if(cnt>lastline-23)cnt=startcnt=lastline-23;
     if(lastline<23)cnt=startcnt=0;
     for(i=1; i<=23; i++)
     { right=0;
       read(); // regular read function //
       if(ch == EOF)
       { for(z=i;z<=23;z++)
	 rightarray[z]=0;
	 break;
	}
       if(right==1)
       rightarray[i]=1;
       else
       rightarray[i]=0;
      }
     show_status();
     key=0;
     searched=1;
     searchsuccess=0;
     return;
    }
   else
   { srch.wincls();
     srch << "\n   Text not found.  Press any key... ";
     srch.wcout(9,4,""); // erase search again //
     getkey();
     srch.winremove();
     w1.wincls();
     cnt=startcnt;
     for(i=1; i<=23; i++)
     { right=0;
       read(); // regular read function //
       if(ch == EOF)
       { for(z=i;z<=23;z++)
	 rightarray[z]=0;
	 break;
	}
       if(right==1)
       rightarray[i]=1;
       else
       rightarray[i]=0;
      }
     key=0;
     saveloc=0;
     lincount=0;
     searched=0;
     return;
    }
 }
void home(void)
{
   if(cnt-23 <= 0)
   return;
   w1.wincls();
   col = cnt = startcnt = 0;
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
 }
void end(void)
{  if (ch==EOF)
   return;
   w1.wincls();
   col = 0;
   cnt = startcnt = lastline-23;
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
 }
void page_down(void)
{
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   if (ch==EOF)
   return;
   w1.wincls();
   if(cnt+23 > lastline)
   cnt = lastline-23;
   startcnt = cnt;
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
 }
void page_up(void)
{
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   if(cnt==23 || lastline <= 23)
   return;
   w1.wincls();
   cnt = cnt-46;
   if(cnt<0)cnt=0;
   startcnt = cnt;
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=3;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
 }
void arrow_down(void)
{
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   if (ch==EOF)
   return;
   w1.winxy(0,0);
   w1.wincleol();
   scroll(0,1,7,1,1,23,78); // scroll screen up 1 line //
   w1.winxy(0,22);
   for(i=1;i<=23;i++)
   { rightarray[i-1] = rightarray[i];
    }
   right=0;
   startcnt = cnt;
   read(); // regular read function //
   if(right==1)
   { rightarray[23]=1;
    }
   else
   { rightarray[23]=0;
    }
   for(i=1;i<=23;i++)
   { if(rightarray[i]==1)
     right=1;
    }
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
   return;
 }
void arrow_up(void)
{
   int savecnt; // control integer //
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   if(cnt - 23 <= 0)
   return;
   w1.winxy(0,22);
   w1.wincleol();
   scroll(1,1,7,1,1,23,78); // scroll screen dn 1 line //
   w1.winxy(0,0);
   savecnt=cnt-24;
   cnt = startcnt = cnt-24;
   for(i=23;i>=1;i--)
   { rightarray[i+1] = rightarray[i];
    }
   right=0;
   read(); // regular read function //
   if(right==1)
   { rightarray[1]=1;
    }
   else
   { rightarray[1]=0;
    }
   for(i=1;i<=23;i++)
   { if(rightarray[i]==1)
     right=1;
    }
   cnt = savecnt+23;
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
   return;
 }
void arrow_left(void)
{
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   if(col==0)
   return;
   if(cnt - 23 >= 0 && lastline > 22)
   cnt = cnt - 23;
   else
   cnt = 0;
   col -= 8;
   if(col<0)col=0;
   w1.wincls();
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
   return;
 }
void arrow_right(void)
{
   regs.h.ah = 0x0C; // fill union with clear keyboard buffer call //

   for(i=1;i<=23;i++)
   { if(rightarray[i]==1)
     right=1;
    }
   if(right==0)
   return;
   if(cnt - 23 >= 0 && lastline > 22)
   cnt = cnt - 23;
   else
   cnt = 0;
   col += 8;
   w1.wincls();
   for(i=1; i<=23; i++)
   { right=0;
     read(); // regular read function //
     if(ch == EOF)
     { for(z=i;z<=23;z++)
       rightarray[z]=0;
       break;
      }
     if(right==1)
     rightarray[i]=1;
     else
     rightarray[i]=0;
    }
   show_status();
   int86(0x21, &regs, &regs); // clear keyb buffer to halt scrolling now //
   return;
 }
void new_file(void)
{
   // save current file name //
   char *savefile = searchpath(filename);
   w1.wincls();

   // close current file //
   fclose(in);

   // get new filename //
   file_select();
   if(fail==1)
   { if(nofile==0)
     { in = fopen(savefile, "rb");
       cnt=24; // trick home function //
       startcnt=0;
       home();
       key=0;
       return;
      }
     key=0;
     return;
    }

   // attemp to open file //
   if((in = fopen(filename, "rb")) == NULL)
   { w1 << "\n  Cannot open " << strupr(filename);
     w1 << ".  Press any key to continue...";
     getkey();
     in = fopen(savefile, "rb");
     cnt=24; // trick home function //
     startcnt=0;
     home();
     return;
    }

   // count lines and ensure line locations fit in memory //
   num=0;
   do
   { ch = fgetc(in); // get char from file //
     if(ch == '\n') // if it's a newline char... //
     { num++; // increment location array //
       if(num==1500)
       pause_win("    Please wait while file is read and loaded...    ");
       if(num>maxsize || ftell(in) > 600000) // 600k max size //
       { pause.winremove();
	 w1 << "\n  " << filename << " is too large.  Press any key to continue...";
	 getkey();
	 fclose(in);
	 if(nofile==0)
	 { in = fopen(savefile, "rb");
	   cnt=24;
	   startcnt=0;
	   home(); // trick home function //
	   return;
	  }
	 pause.winremove();
	 w1.wincls();
	 return;
	}
      }
    } while (ch != EOF);

   // display new filename //
   show(3,25,"                    ");
   sprintf(showstring, "File:  %s", strupr(filename)); // concat filename //
   show(3,25,showstring); // show filename in lower bar //

   // pinpoint long locations for beginning of lines //
   rewind(in); // reset to beginning of file //
   loc[0] = ftell(in); // store BOF as loc[0] //
   num=1;
   do
   { ch = fgetc(in); // get char from file //
     if(ch == '\n') // if it's a newline char... //
     { loc[num] = ftell(in); // store location in array //
       num++; // increment location array //
      }
    } while (ch != EOF);
   lastline=num; // save total as lastline //
   pause.winremove();

   // display first screenfull with home function //
   nofile=0;
   cnt=24; // trick home function //
   startcnt=0;
   home();
   return;
 }
void file_select(void)
{
   DIR *directory;
   struct dirent *ent;
   int save, disk, dirnum;
   unsigned attrib;
   char buffer[MAXPATH];
   char string[15], temp[15];

   // start or newscan //
   newscan : fail=0; dirnum=0; newscan=0;

   // get drives except current drive //
   save = getdisk(); // save original disk for later reset //
   for (disk = 0;disk < 26;++disk) // for a through z //
   { setdisk(disk); // try to set disks //
     if (disk == getdisk()) // if disk exists //
     { if(save != disk) // and its not the current disk //
       { sprintf(array[dirnum], "a[-%c-]", disk + 'A'); // copy into array //
	 dirnum++;            //  start with "a" to aid sorting later //
	}
      }
    } setdisk(save); // reset to original disk //

   // open directory for reading //
   if ((directory = opendir(getcwd(buffer, MAXPATH))) == NULL) // open //
   { perror("Unable to open directory");
     exit(1);
    }

   // get directories and files //
   while ((ent = readdir(directory)) != NULL) // read current directory //
   { if(strcmp(ent->d_name,".") != 0) // skip root dir //
     { _dos_getfileattr(ent->d_name,&attrib); // get attributes //
       if(attrib & _A_SUBDIR || strcmp(ent->d_name,"..")==0) // if it is a subdirectory //
       { sprintf(array[dirnum], "b%s\\", ent->d_name);
	 dirnum++;            //  start with "b" to aid sorting later //
	}
       else            // not system or hidden files //
       { if(!(attrib & _A_HIDDEN || attrib & _A_SYSTEM))
	 { sprintf(array[dirnum], "c%s", ent->d_name);
	   dirnum++;            //  start with "c" to aid sorting later //
	  }
	}
      }
     if(dirnum==100)
     pause_win("  Please wait while directory listing is formed...  ");
    }
   closedir(directory); // close directory //

   // if sort by extension is requested, prepare entries by //
   // changing from cfname.ext to cext.cfname //
   if(sortorder==1) // if sort by extension is requested //
   { for(i=0; i<dirnum; i++)
     { if(array[i][0] == 'c')
       { char *dot = strchr(array[i], '.');
	 if(dot) // if file has an extension //
	 { // prep for extension sort //
	   strcpy(string, array[i]);
	   char *ext = strchr(string, '.');
	   if(ext)
	   ext++;
	   strncpy(temp, string, ext-string-1);
	   temp[ext-string-1] = NUL;
	   sprintf(array[i], "c%s.%s", ext, temp);
	  }
	 else // if file has no extension put a space as the extension //
	 { strcpy(temp, array[i]);
	   sprintf(array[i], "c .%s", temp);
	  } // no extension files now guaranteed to be first after sort //
	}
      }
    }

   // alhabetical sort by filename or extension as per request. //
   // always a's (drives), then b's (directories), then c's (files) //
   qsort((void *)array, dirnum, sizeof(array[0]), sort_function);

   // if sorted by extension, fix prepared entries by //
   // changing back from cext.cfname to cfname.ext //
   if(sortorder==1) // if sort by extension was requested //
   { for(i=0; i<dirnum; i++)
     { if(array[i][0] == 'c')
       { char *dot = strchr(array[i], '.');
	 if(dot)
	 { if(array[i][1] != ' ') // if file had an extension //
	   { strrev(array[i]);
	     LAST_CHAR(array[i]) = NUL;
	     char *ext = strchr(array[i], '.');
	     if(ext)
	     ext++;
	     strncpy(temp, array[i], ext-array[i]-1);
	     temp[ext-array[i]-1] = NUL;
	     sprintf(array[i], "%s.%s", strrev(temp), strrev(ext));
	    }
	   else // if file had no extension remove the space //
	   { strrev(array[i]);
	     strncpy(temp, array[i], strlen(array[i])-3);
	     temp[strlen(array[i])-3] = NUL;
	     sprintf(array[i], "%s", strrev(temp));
	    }
	  }
	}
      }
    }

   // remove sorting aid a's, b's, and c's //
   for(i=0; i<=dirnum; i++)
   { strrev(array[i]);
     LAST_CHAR(array[i]) = NUL;
     strrev(array[i]);
    }
   pause.winremove();

   // get file selection from scroll_select function //
   scroll_select(dirnum); // dirnum is one more than numelements to keep //
   if(newscan==1)         // the list null terminated for reliability //
   { goto newscan;
    }
   return;
 }
int sort_function( const void *a, const void *b) // example from B TC 3.0 //
{  // modified to sort a list of pointers to pointers of strings //
   return strcmp(*(char **)a, *(char **)b);
}
void scroll_select(int numelements)
{
   int y, startnum, pagenum, elementnum, amount;
   char drive[5];
   int match[1000], m, matchnum; // for selecting by first letter //
   int maxpage = ((numelements-1) / 17) + 1; // make 1st page = 1 //

   // build and display scroll window //
   if(vmode == 3) { scrollwin.setcolor(white); scrollwin.setbkcolor(blue); }
   else { scrollwin.setcolor(black); scrollwin.setbkcolor(lightgray); }
   scrollwin.winput();
   scrollwin.setcolor(lightgray); scrollwin.setbkcolor(black);
   scrollwin.wincls();
   show(33,3,"ESC=Abort");
   show(47,3,"Up ");
   show(47,23,"Dn ");
   show(33,23,"F5=Chg-Sort");
   Mtrap(32, 3, 50, 23);

   // display first screenfull //
   if(numelements<17) amount = numelements-1;
   else amount = 16;
   scrollwin << "\n";
   for(i=0;i<=amount;i++)
   scrollwin << "  " << array[i] << "\n";
   scrollwin.winxy(2,1); // position of first name //
   scroll_show(array[0]); // show item 1 highlighted //
   scrollwin.winxy(2,1); // position of first name //

   elementnum=0; startnum=0; pagenum=1; // reset all counters //
   mcnt=0;
   while(key != 27) // if not escape //
   { switch(key = getkey()) {
     case 27: fail=1; break;
     case 9: /* tab */
     case 327: /*home*/
	       if(elementnum==0)
	       break;
	       scrollwin.wincls();
	       if(numelements<17) amount = numelements-1;
	       else amount = 16;
	       scrollwin << "\n";
	       for(i=0;i<=amount;i++)
	       scrollwin << "  " << array[i] << "\n";
	       scrollwin.winxy(2,1); // position of first name //
	       scroll_show(array[0]); // show item 1 highlighted //
	       scrollwin.winxy(2,1); // position of first name //
	       elementnum=0; startnum=0; pagenum=1; // reset counters //
	       break;

     case 335: /*end*/
	       if(elementnum==numelements-1)
	       break;
	       pagenum=maxpage; // last page //
	       startnum = ((maxpage-1) * 17); // first element on last page //
	       elementnum=numelements-1; // last element number //
	       scrollwin.wincls();
	       scrollwin << "\n";
	       for(i=startnum;i<=numelements-1;i++)
	       scrollwin << "  " << array[i] << "\n";
	       i=elementnum-startnum; // position of element on page //
	       scrollwin.winxy(2,1+i); // move to position of element //
	       scroll_show(array[elementnum]); // highlighted //
	       scrollwin.winxy(2,1+i); // beginning of element //
	       break;

     case 319: /*F5*/
	       if(sortorder==0)
	       sortorder=1;
	       else
	       sortorder=0;
	       newscan=1;
	       scrollwin.winremove();
	       Mtrap(1,1,80,25);
	       return;

     case 336: /* dn */
	       if(elementnum==numelements-1)
	       break;
	       if(elementnum==startnum+16)
	       { goto pgdn;
		}
	       scrollwin << array[elementnum]; // plain //
	       elementnum++;
	       y = scrollwin.gety() + 1;
	       scrollwin.winxy(2,y);
	       scroll_show(array[elementnum]); // highlighted //
	       scrollwin.winxy(2,y);
	       break;

     case 328: /* up */
	       if(elementnum==0)
	       break;
	       if(elementnum==startnum) // pgup w/last item highlighted //
	       { pagenum--;
		 startnum = (pagenum * 17) - 17;
		 scrollwin.wincls();
		 scrollwin << "\n";
		 for(i=startnum;i<=startnum+16;i++)
		 scrollwin << "  " << array[i] << "\n";
		 elementnum=startnum+16;
		 scrollwin.winxy(2,17); // position of last name //
		 scroll_show(array[elementnum]);
		 scrollwin.winxy(2,17); // position of last name //
		 break;
		}
	       scrollwin << array[elementnum];
	       elementnum--;
	       y = scrollwin.gety() - 1;
	       scrollwin.winxy(2,y);
	       scroll_show(array[elementnum]);
	       scrollwin.winxy(2,y);
	       break;

     case 337: /*pgdn*/
	       pgdn : if(pagenum==maxpage)
	       break;
	       pagenum++;
	       elementnum = startnum = ((pagenum * 17) - 17);
	       scrollwin.wincls();
	       scrollwin << "\n";
	       if(startnum+17>numelements-1)
	       amount=numelements-1;
	       else
	       amount=startnum+16;
	       for(i=startnum;i<=amount;i++)
	       scrollwin << "  " << array[i] << "\n";
	       scrollwin.winxy(2,1); // position of first name //
	       scroll_show(array[elementnum]);
	       scrollwin.winxy(2,1); // position of first name //
	       break;

     case 329: /*pgup*/
	       if(pagenum==1)
	       break;
	       pagenum--;
	       elementnum = startnum = (pagenum * 17) - 17;
	       scrollwin.wincls();
	       scrollwin << "\n";
	       for(i=startnum;i<=startnum+16;i++)
	       scrollwin << "  " << array[i] << "\n";
	       scrollwin.winxy(2,1); // position of first name //
	       scroll_show(array[elementnum]);
	       scrollwin.winxy(2,1); // position of first name //
	       break;

     case 13:  /* enter */
	       // drives - remove if not a directory list //
	       if(array[elementnum][0] == '[' && array[elementnum][1] == '-'
	       && array[elementnum][3] == '-' && array[elementnum][4] == ']')
	       { sprintf(drive,"%c:", array[elementnum][2]);
		 cd(drive);
		 newscan=1;
		 scrollwin.winremove();
		 Mtrap(1,1,80,25);
		 return;
		}
	       // directories - remove if not a directory list //
	       if(LAST_CHAR(array[elementnum]) == '\\')
	       { LAST_CHAR(array[elementnum]) = NUL;
		 chdir(array[elementnum]);
		 newscan=1;
		 scrollwin.winremove();
		 Mtrap(1,1,80,25);
		 return;
		}
	       // any other type of item //
	       // copy into any string or return the item //
	       else
	       { strcpy(filename,array[elementnum]); // copy to filename //
		 scrollwin.winremove();
		 Mtrap(1,1,80,25);
		 return;
		}

     case 999: // mouse clicked //
	       if(M_ypos==3 && M_xpos>=47 && M_xpos<=50)
	       { /*pgup*/
		 if(pagenum==1)
		 break;
		 pagenum--;
		 elementnum = startnum = (pagenum * 17) - 17;
		 scrollwin.wincls();
		 scrollwin << "\n";
		 for(i=startnum;i<=startnum+16;i++)
		 scrollwin << "  " << array[i] << "\n";
		 scrollwin.winxy(2,1); // position of first name //
		 scroll_show(array[elementnum]);
		 scrollwin.winxy(2,1); // position of first name //
		 break;
		}
	       if(M_ypos==23 && M_xpos>=47 && M_xpos<=50)
	       { /*pgdn*/
		 if(pagenum==maxpage)
		 break;
		 pagenum++;
		 elementnum = startnum = ((pagenum * 17) - 17);
		 scrollwin.wincls();
		 scrollwin << "\n";
		 if(startnum+17>numelements-1)
		 amount=numelements-1;
		 else
		 amount=startnum+16;
		 for(i=startnum;i<=amount;i++)
		 scrollwin << "  " << array[i] << "\n";
		 scrollwin.winxy(2,1); // position of first name //
		 scroll_show(array[elementnum]);
		 scrollwin.winxy(2,1); // position of first name //
		 break;
		}
	       if(M_xpos>34 && M_xpos<48 && M_ypos<22 && M_ypos>4)
	       { // clicked on element //
		 save=elementnum; // save current elementnum //
		 elementnum = (M_ypos - 5) + startnum; // calculate new num //
		 if(elementnum>numelements-1) // if past last item //
		 { elementnum=save; // reset to original elementnum //
		   break; // do nothing //
		  }
		 // drives - remove if not a directory list //
		 if(array[elementnum][0] == '[' && array[elementnum][1] == '-'
		 && array[elementnum][3] == '-' && array[elementnum][4] == ']')
		 { sprintf(drive,"%c:", array[elementnum][2]);
		   cd(drive);
		   newscan=1;
		   scrollwin.winremove();
		   Mtrap(1,1,80,25);
		   return;
		  }
		 // directories - remove if not a directory list //
		 if(LAST_CHAR(array[elementnum]) == '\\')
		 { LAST_CHAR(array[elementnum]) = NUL;
		   chdir(array[elementnum]);
		   newscan=1;
		   scrollwin.winremove();
		   Mtrap(1,1,80,25);
		   return;
		  }
		 // any other item //
		 // copy into any string or return the item //
		 else
		 { strcpy(filename,array[elementnum]); // cpy to flnm //
		   scrollwin.winremove();
		   Mtrap(1,1,80,25);
		   return;
		  }
		}
	       // ESC //
	       if(M_xpos>=33 && M_xpos<=35 && M_ypos==3)
	       { key=27;
		 fail=1;
		 scrollwin.winremove();
		 Mtrap(1,1,80,25);
		 return;
		}
	       if(M_xpos>=33 && M_xpos<=34 && M_ypos==23)
	       { if(sortorder==0)
		 sortorder=1;
		 else
		 sortorder=0;
		 newscan=1;
		 scrollwin.winremove();
		 Mtrap(1,1,80,25);
		 return;
		}
	       break;
     default:  // speed select by first letter and move highlight //
	       save=pagenum; // save current page number //
	       matchnum=0; // zero match array //
	       for(m=0; m<numelements; m++) // scan for matching first letters //
	       { if(array[m][0] == toupper(key))
		 { match[matchnum] = m;    // build array of all matches //
		   matchnum++;
		  }
		}
	       if(matchnum==0) // no match found //
	       { break;
		}

	       // set number to first or next match //
	       if(array[elementnum][0] == toupper(key)) // still in same letter selection //
	       { m=elementnum+1; // advance by one //
		 if(array[m][0] != toupper(key)) // if past last match //
		 { for(i=m; i<numelements; i++) // test for split match //
		   { if(array[i][0] == toupper(key))
		     { m=i;
		       break;
		      }
		     else  // if rest of array contains no more matches //
		     m=match[0];
		    }
		  }
		}
	       else // first time matching letter is pressed //
	       { m=match[0];
		}
	       if(m==numelements) // keep within list //
	       m=match[0];

	       // find page elementnum is on //
	       pagenum=m / 17;
	       if(pagenum == 0)
	       pagenum=1;
	       else
	       pagenum=pagenum+1;

	       // unhighlight current //
	       scrollwin << array[elementnum];

	       // calculate page of new element //
	       startnum = ((pagenum * 17) - 17);
	       elementnum=m; // new current element number //

	       // show all elements on new page if not on current page //
	       if(pagenum!=save)
	       { scrollwin.wincls();
		 scrollwin << "\n";
		 if(startnum+17>numelements-1)
		 amount=numelements-1;
		 else
		 amount=startnum+16;
		 for(i=startnum;i<=amount;i++)
		 scrollwin << "  " << array[i] << "\n";
		}

	       // highlight correct element //
	       i=elementnum-startnum; // position of element on page //
	       scrollwin.winxy(2,1+i); // move to position of element //
	       scroll_show(array[elementnum]); // highlighted //
	       scrollwin.winxy(2,1+i); // reset to beginning of element //

	       break; // end of default case //
      } // end of switch(key) //
    } // end if key==27 //
   key=0;
   scrollwin.winremove();
   Mtrap(1,1,80,25);
   return;
 }
int cd(char *cdname) // change to verified drive //
{
   int drivename, handle;
   char value[5], drvtest[15];

   drivename = cdname[0] - 'A';
   save = drivename; // save the drivename so it is still viable later //
   sprintf(drvtest, "%c:testtest.tst", cdname[0]); // build test name //
   sprintf(value, "0x%x",
   _dos_open(drvtest, O_RDONLY, &handle)); // test open on new drive //
   // new interrupt 24 handler will return to here with value if bad //
   if(strcmp(value, "0x3") == 0) // bad on floppy //
   { return -1; }
   if(strcmp(value, "0x5") == 0) // bad on CD or network //
   { return -1; }
   if((strcmp(value, "0x2") == 0)||(strcmp(value, "0x0") == 0)) // ok //
   setdisk(save); // set new drive //
   chdir("\\"); // set root directory //
   return 1;
 }
void read_help(void)
{
   if(vmode == 3) { help.setcolor(white); help.setbkcolor(blue); }
   else { help.setcolor(black); help.setbkcolor(lightgray); }
   help.winput();
   help.setcolor(lightgray); help.setbkcolor(black);
   help.wincls();

   qprintf(5,3,7,  "               General Instructions for READ File Viewer");
   qprintf(5,5,7,  "Overview:  READ is a simple text file viewer with many handy features");
   qprintf(5,6,7,  "such as full mouse support if a mouse is installed, Input File Selector,");
   qprintf(5,7,7,  "Text Search Utility, and a full compliment of status indicators such as");
   qprintf(5,8,7,  "Filename, Line total, Current line, Current column, and File percentage.");
   qprintf(5,9,7,  "Read also has a draggable scroll bar for file scrolling.");
   qprintf(5,11,7, "  Keyboard Usage:   Pg Up        =  move up one page in file");
   qprintf(5,12,7, "                    Pg Dn        =  move down one page in file");
   qprintf(5,13,7, "                    Left Arrow   =  move display left 8 spaces");
   qprintf(5,14,7, "                    Right Arrow  =  move display right 8 spaces");
   qprintf(5,15,7, "                    Home         =  move to start of file");
   qprintf(5,16,7, "                    End          =  move to end of file");
   qprintf(5,17,7, "                    F10          =  load new file");
   qprintf(5,18,7, "                    F2,F3        =  search, search again");
   qprintf(5,19,7, "                    ESC          =  exit viewer");
   qprintf(5,21,7, "  Mouse Usage:   The mouse is used by clicking on the name of the");
   qprintf(5,22,7, "                 desired function, such as: F1=Help, F2=Search,");
   qprintf(5,23,7, "                 F10=New, Home, End, PgUp, PgDn, <, >, or ESC.");
   while(key != 27)
   { switch(key = getkey()) {
     case 27: break;
     case 999: if(M_ypos == 1 && M_xpos >= 7 && M_xpos <= 9) { key = 27; } break;
     default: break;
     }
    }
   help.winremove();
   key=0;
   return;
 }
int error_win(char *msg)
{
   int xl, xr, half;

   half = strlen(msg) / 2;
   xl = 40 - half - 3;
   xr = 40 + half + 3;
   wintype err(xl, 10, xr, 12, 1, "");
   err.setcolor(white); if(vmode==3) err.setbkcolor(red);
   else err.setbkcolor(black); err.winput(); err.wincls();
   err.line_border();
   err << "  " << msg;
   Mtrap(1,1,80,25);
   rekey : switch(key = getkey())
   { case 27 :
     case 'A':
     case 'a': err.winremove(); return (_HARDERR_FAIL);
     case 'R':
     case 'r': err.winremove(); return (_HARDERR_RETRY);
     case 999 : if(M_ypos==12)
		{ if((M_xpos>=(xl+strlen(msg)-17))&&(M_xpos<=(xl+strlen(msg)-11)))
		  { return(_HARDERR_FAIL);
		   }
		  if((M_xpos>=(xl+strlen(msg)-7))&&(M_xpos<=(xl+strlen(msg)-1)))
		  { return(_HARDERR_RETRY);
		   }
		 }
     default : goto rekey;
    }
 }
#pragma warn -par
void far handler(unsigned deverr, unsigned errval, unsigned far *devhdr)
{
   static char msg[80];
   int drive;
   int errorno;

   if (deverr & 0x8000) {
      error_win("Device error");
     _hardretn(5);
   }
   drive = deverr & 0x00FF;
   errorno = errval & 0x00FF;
   sprintf(msg, "%s on drive %c...   (A)bort   (R)etry   ?", err_msg[errorno], 'A' + drive);
   _hardresume(error_win(msg));
}
#pragma warn +par
int main(int argc, char *argv[])
{
   struct text_info ti; // structure to hold cursor position //

   // allocate far storage for 15000, or if not, 3000 line positions //
   loc=(unsigned long far *)farcalloc(15001,sizeof(unsigned long));
   if(loc != NULL) // should be able to get 15000 //
   maxsize=15000;
   else // can always get 3000 //
   { loc=(unsigned long far *)farcalloc(3001,sizeof(unsigned long));
     maxsize=3000;
    }

   // allocate storage for 1001 pointers to string pointers //
   array=(char **)calloc(1001,sizeof(char *));

   // allocate space for entry (except last to leave array null terminated) //
   for(i=0; i<1000; i++)
   array[i]=(char *)calloc(13,sizeof(char));

   // ensure mem is allocated //
   if(loc==NULL || array==NULL)
   { fprintf(stderr, "Error allocating memory.");
     exit(1);
    }

   // save original cursor position for restoration on exit //
   gettextinfo(&ti);

   // test for valid file on cmd line //
   if(argc>1)
   { if((in = fopen(argv[1], "rb")) == NULL)
     { printf("Cannot find file:  %s.  Press any key to select... ",strupr(argv[1]));
       getch();
       gotoxy(1,ti.cury);
       delline();
       gettextinfo(&ti);
       nofile=1;
      }
    }

   // screen and mouse initialization and setup //
   _harderr(handler); // install int 24 handler //
   set_v_ptr(); // set video pointer //
   qp_init(); // initialize qprintf fast screen writing //
   Mreset(); // reset mouse //
   Minsthandler(); // install mouse handler //
   mcnt=0; // set mouse repeat/delay monitor to zero //
   _setcursortype(_NOCURSOR); // turn off cursor //
   if(vmode==3) { w1.setcolor(white); w1.setbkcolor(blue); }
   else { w1.setcolor(black); w1.setbkcolor(lightgray); }
   fc = w1.getcolor(); // save forground color of border //
   bc = w1.getbkcolor(); // save background color of border //
   w1.winput(); // pop up window //
   w1.setcolor(lightgray); w1.setbkcolor(black); // set viewport to B/W //
   w1.wincls(); // clear viewport //

   // test command line arguments //
   if(argc < 2 || nofile==1)
   { nofile=1;
     strcpy(filename,"No File");
    }

   // attemp to open file if provided //
   if(nofile==0)
   { if((in = fopen(argv[1], "rb")) == NULL)
     { fprintf(stderr, "Error opening %s.", strupr(argv[1]));
       exit(1);
      }
    }

   // parse filename from argv[1] if provided //
   if(nofile==0)
   { char *pfile = strrchr(argv[1], '\\'); // search backwards for '\' //
     if(pfile) // if '\' //
     { pfile++; // increment into pfile //
       strcpy(filename, pfile); // copy pfile to filename for display //
      }
     else // if no '\' in argv[1] //
     { strcpy(filename, argv[1]); // copy argv[1] to filename for display //
      }
    }

   // write filename in lower bar //
   sprintf(showstring, "File:  %s", strupr(filename)); // concat filename //
   show(3,25,showstring); // show filename in lower bar //

   // pinpoint long locations for beginning of lines if file is provided //
   if(nofile==0)
   { num=0;
     do
     { ch = fgetc(in); // get char from file //
       if(ch == '\n') // if it's a newline char... //
       { num++; // increment location counter //
	 if(num==1500)
	 pause_win("    Please wait while file is read and loaded...    ");
	 if(num>maxsize || ftell(in) > 600000) // max size 600k //
	 { pause.winremove();
	   w1.winremove();
	   _setcursortype(_NORMALCURSOR);
	   gotoxy(ti.curx,ti.cury);
	   printf("File too large.");
	   exit(1);
	  }
	}
      } while (ch != EOF);

     // pinpoint long locations for beginning of lines //
     rewind(in); // reset to beginning of file //
     loc[0] = ftell(in); // store BOF as loc[0] //
     num=1;
     do
     { ch = fgetc(in); // get char from file //
       if(ch == '\n') // if it's a newline char... //
       { loc[num] = ftell(in); // store location in array //
	 num++; // increment location array //
	}
      } while (ch != EOF);
     lastline=num; // save total as lastline //
     pause.winremove();
    }

   // make seek to desired line if argc 3 is provided //
   if(argc == 3)
   cnt = startcnt = ("%d") ? atoi(argv[2]) : 0;
   if(cnt < 0 || cnt > lastline) // if negative or larger than file //
   cnt = startcnt = 0;

   // display first screenfull if file is provided //
   if(nofile==0)
   { for(i=1; i<=23; i++)
     { right=0;
       read(); // regular read function //
       if(ch == EOF)
       { for(z=i;z<=23;z++)
	 rightarray[z]=0;
	 break;
	}
       if(right==1)
       rightarray[i]=1;
       else
       rightarray[i]=0;
      }
     show_status();
    }

   // if no file on cmd line, get one //
   if(nofile==1)
   new_file();

   searched=0; // no search conducted yet //

   // main user input and display processing loop //
   while(key != 27)
   { key=getkey();
     switch(key)
     { case 27: break;
       case 315: read_help(); break;
       case 324: searched=0; saveloc=0; lincount=0; new_file(); break;
       case 316: if(nofile==0) search(); break;
       case 327: if(nofile==0) home(); break;
       case 335: if(nofile==0) end(); break;
       case 329: if(nofile==0) page_up(); break;
       case 337: if(nofile==0) page_down(); break;
       case 328: if(nofile==0) arrow_up(); break;
       case 336: if(nofile==0) arrow_down(); break;
       case 331: if(nofile==0) arrow_left(); break;
       case 333: if(nofile==0) arrow_right(); break;
       case 999: // leftmouse //
		 if(M_ypos == 1)
		 { if(M_xpos >= 3 && M_xpos <= 5){ key = 27; break; }
		   if(M_xpos >= 17 && M_xpos <= 23){ read_help(); break; }
		   if(M_xpos >= 37 && M_xpos <= 43){ searched=0; saveloc=0; lincount=0; new_file(); break; }
		   if(nofile==1) break;
		   if(M_xpos >= 26 && M_xpos <= 34){ search(); break; }
		   if(M_xpos >= 46 && M_xpos <= 49){ home(); break; }
		   if(M_xpos >= 52 && M_xpos <= 54){ end(); break; }
		   if(M_xpos >= 57 && M_xpos <= 60){ page_up(); break; }
		   if(M_xpos >= 63 && M_xpos <= 66){ page_down(); break; }
		   if(M_xpos == 69){ arrow_up(); break; }
		   if(M_xpos == 72){ arrow_down(); break; }
		   if(M_xpos == 75){ arrow_left(); break; }
		   if(M_xpos == 78){ arrow_right(); break; }
		  }
		 if(M_xpos == 80)
		 { if(nofile==1) break;
		   if(M_ypos == 1){ arrow_up(); break; }
		   if(M_ypos == 25){ arrow_down(); break; }
		   if((M_ypos > ypos+1)&&(M_ypos < 25)){ page_down(); break; }
		   if((M_ypos < ypos+1)&&(M_ypos > 1)){ page_up(); break; }
		   if(M_ypos == ypos+1) // drag scroll bar //
		   { do
		     { if((M_ypos < ypos+1)&&(M_ypos >= 2)) // keep in range //
		       { show(80,ypos+1,""); // redraw bar at old loc //
			 show(80,M_ypos,""); // draw new pos indicator //
			 ypos=ypos-1; // update yposition counter //
			}
		       if((M_ypos > ypos+1)&&(M_ypos <= 24)) // keep in range //
		       { show(80,ypos+1,""); // redraw bar at old loc //
			 show(80,M_ypos,""); // draw new pos indicator //
			 ypos=ypos+1; // update yposition counter //
			}
		      } while(L_DOWN); // while dragging //
		     if(ypos==1) // if top of scroll bar //
		     home();
		     else if(ypos==23) // if bottom of scroll bar //
		     end();
		     else
		     jump_read(); // if somewhere else on scroll bar //
		    }
		   break;
		  }
		 break;
       default : break;
      }
    }
   // normal exit //
   if(in) // if file is open //
   fclose(in); // close input file //
   free(array); // free array memory //
   farfree(loc); // free far loc memory //
   w1.winremove(); // remove screen //
   _setcursortype(_NORMALCURSOR); // turn cursor back on //
   gotoxy(ti.curx, ti.cury); // goto saved cursor position //
   Mhide(); // hide mouse //
   Mreset(); // reset mouse //
   return 0; // exit //
 }
