/* Interrupt Driven Sound 

This is a program that willl play simple music over the PC-Speaker.  It
uses the clock-tick interupt, so it will run at the same speed on all machines.
MAXBUFFER is the maximum size of the recorded buffer.  The music repeats until
told to stop, good for background music in games.

-=- void initsound(); -=-
This function starts the interupts.  It must be called to play any sound.
You may call any of the other functions, except stop(), they will work normally
BUT no sound will be played.

-=- void shutdown(); -=-
This will shut down the player, and get rid of all the interupts.  Call
this before you shut your program down.

-=- void stop(); -=-
This function stops the music.

-=- void resume(); -=-
This function restarts the music after a call to stop();

-=- void CLEAR(); -=-
This clears out the music buffer.  To play additional music, you must call
play() statement, and a resume() statement.

-=- void play(char buf[]); -=-
The function play(*char) takes in a string of music, and appends it to the
end of the current sequence.  Old music, already played is not deleted from
the buffer.  Here are the commands for the string:

	* Stop playing (Usefull for end of song.)
	Q Set next notes to Quater notes
	W  "   "    "    "  Whole notes
	H  "   "    "    "  Half notes
	T  "   "    "    "  Eigth notes
	+  Increases the note length by 1  Clock Ticks
	-  Decreases "    "     "    "  1  Clock Ticks
	{    "  "    "    "     "    "  10 Clock Ticks
	}  Increases "    "     "    "  10 Clock Ticks
	?  Set current note length to   50 Clock Ticks
      A-G  Plays the lettered note
      a-g  Plays the lettered note up an octave
      ' ' (Space) Plays a rest


This file is being given as public domain.  If you change anything you MUST
put a comment at the end of the line like this //CHANGED LINE xx/xx/xx
where xx/xx/xx is the date, otherwise have fun with it. To get a version
for SoundBlaster send $5.00 plus $1.37 (For shipping, handling, disk) to:
	Marc Hughes
	5 Cooper St.
	Auburn, MA 01501

DISCLAIMER:
	I will not be held responsible for anything going wrong with your
	computer, if you don't agree with this, delete this file imediately!!

*/
#include <dos.h>

void play(char buf[]);
void stop();
void resume();
void initsound();

void shutdown();

#define MAXBUFFER 2048

main()
	{
	initsound();
	play("ABCDEFGabcdefg  "); // A scale.
	play("?{{{{EDCDEE}E{DD}D{EE}E{EDCDEE}E{++DDED--}C   "); //Merrily we roll along
	// You can put anyhting here, and the music will continue to play...

	while(!kbhit())
		{
		printf("This is just some sample code, to show it works");
		}
	stop();
	shutdown();
	}


#define INTR 0x1C  //Clock Tick Interupt
void interrupt ( *oldhandler)(void);

char music[MAXBUFFER];
int length,num,dur,pl;
int freq[7]={220,247,262,294,330,349,392};
int hfreq[7]={439,493,523,583,656,699,783};
int curdur=1;

void CLEAR(){length=0;stop();}
void interrupt musichandler(void)
{
hi:
   dur-=2;
   if(pl==0){goto t;}
   if(dur>0){goto t;}
    num++;
   if(num > strlen(music)){num=0;}
   if(music[num]==' '){nosound();dur=curdur;goto t;}
   else if(music[num]=='*'){pl=0;}       // Stop playing (End of song?)
   else if(music[num]=='Q'){curdur=10;goto hi;}  //Quater note
   else if(music[num]=='W'){curdur=40;goto hi;}  //Whole note
   else if(music[num]=='H'){curdur=20;goto hi;}  //Half note
   else if(music[num]=='T'){curdur=5;goto hi;}   //Eigth note
   else if(music[num]=='+'){curdur++;goto hi;}
   else if(music[num]=='-'){curdur--;goto hi;}
   else if(music[num]=='{'){curdur-=10;goto hi;}
   else if(music[num]=='}'){curdur+=10;goto hi;}
   else if(music[num]=='?'){curdur=50;goto hi;}
   else if( (music[num]>64) && (music[num]<72) ){nosound();sound(freq[music[num]-65]);dur=curdur;goto t;}
   else if( (music[num]>96) && (music[num]<104) ){nosound();sound(hfreq[music[num]-97]);dur=curdur;goto t;}
   else{num++;dur=0;}
   t:
   oldhandler();
}

void play(char buf[])
	{
	curdur=5;
	length+=strlen(buf);
	strcat(music,buf);
	curdur=20;
	dur=0;
	num=-1;
	pl=1;
	}
void stop(){pl=0;nosound();}
void resume(){pl=1;}
void initsound()
	{
	dur=1;
	pl=1;
	length=0;
	num=0;
	strcpy(music,"");
	oldhandler = getvect(INTR);
	setvect(INTR, musichandler);
	return; 
	}
void shutdown()
	{
	nosound();
	setvect(INTR,oldhandler);
	return;
	}