/*****************************************************************************
*
* Header file for :
*
* Base to base conversion DLL. Version 1.0 Beta
* Copyright (C) 1995 Sammy Yousef
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation.
*
* This DLL is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* This library provides routines for conversion of numbers between bases.
* Storing the number as a double floating point does cause inaccuracies in
* the translations. It is intended for use in Windows which is a trademark
* of the Microsoft Corporation. This DLL received only minimal testing.
*
* This library was written for readability and ease of use NOT efficiency
*
* *##################*Use this DLL at your own risk.*###################*
*
* If you use the DLL and have any comments feel free to email me. 
* I would be most grateful for any feedback about either the quality of the
* code or the reliability of these routines.
*
* Author : Sammy Yousef
*              syousef@socs.uts.edu.au
*              syousef@ghostgum.itd.edu.au
*              sammy@ftoomsh.socs.uts.edu.au
*
*          Also known as Whiteheart on the talkers.
*
* Date   : 2 August 1995
*
*****************************************************************************/

/*************************** Definitions of Constants *************************/

#define MAXSTRINGIN 81          /* set maximum length of an input number */
#define MAXBASE 36              /* the maximum base supported by the program */
#define MAXSTRINGOUT 302        /* set maximum length of an output number to 
                                   a reasonable number - we couldn't allocate
                                   enough mem for the full range of conversion
                                   because worst case is as follows :
                                   based on converting from base 35 to base 2
                                   with 80 digits ie sqrt(35 to power 81) */ 
#define MAXDECIMAL 70           /* maximum number of decimal places in output */
