/*------------------------------------------------------------------------*/
/*                                                                        */
/*  test.H                                                                */
/*                                                                        */
/*  Copyright (c) 1995 Kalev Kuusik                                       */
/*  All Rights Reserved                                                   */
/*                                                                        */
/*------------------------------------------------------------------------*/

#if !defined( TEST_H )
#define TEST_H

#if !defined( __DUMMY_H )
#include <dummy.h>
#endif // __DUMMY_H

#if defined( __DUMMY2_H )
#pragma option -vo
#endif // __DUMMY2_H

/*------------------------------------------------------------------------*/
/*                                                                        */
/*  template <class T> class TemplateClass                                */
/*                                                                        */
/*                                                                        */
/*------------------------------------------------------------------------*/

template <class T,class Alloc> class AnyClass;

#if defined( T_NAMES1 )
#define AC AnyClass
int AnyCFunction(char* a, int b=0);
void CFunction(bool pu);
#endif // T_NAMES1

template <class T,class Alloc>
unsigned TemplateClass<T,Alloc>::StaticData = 0;

template <class T,class Alloc> class TemplateClass
{

public:
    TemplateClass( const T& t, TemplateClass<T,Alloc> *p ) : Data(t){};
    TemplateClass();

    void *operator new( size_t sz );
    void operator delete( void * );

private:
    friend Initializer<T,Alloc>;
    static unsigned StaticData;

protected:    
    TemplateClass<T,Alloc> *Next;
    T Data;
};

#if defined( T_NAMES2 )
#define TC TemplateClass
bool CFunction(void* gon);
#endif // T_NAMES2

template <class T,class Alloc>
inline TemplateClass<T,Alloc>::TemplateClass()
{
    Next = 0;
}

template <class T,class Alloc>
void *TemplateClass<T,Alloc>::operator new( size_t sz )
{
    return Mgr->Allocate( sz );
}

template <class T,class Alloc>
void TemplateClass<T,Alloc>::operator delete( void *b )
{
    Mgr->Free( b );
}

/*------------------------------------------------------------------------*/
/*                                                                        */
/*                                                                        */
/*------------------------------------------------------------------------*/

class OrdinaryClassBase1 {
  int Data;

public:
   OrdinaryClassBase1(int data);
};

class OrdinaryClassBase2;


class OrdinaryClass :
    private OrdinaryClassBase1, public  OrdinaryClassBase2
{

public:

    typedef int  (*XFunc)(const T &, void *);
    friend  int FriendFunc(char* data);

    OrdinaryClass();
    ~OrdinaryClass()
        {
        Fun5();
        }

    int Fun1( const T& t );
    T *Fun2( const T& t, int a );    

    const T& Fun3() const
        {
        return Data1->Data2;
        }

    T Fun4( const T& t )
        {
        return Fun12( t, 0 );
        }

    void Fun5()
        {
        Fun7();
        }

    void Fun6( XFunc iter, void *args );

# if defined( T_NAMES )
    void fun1( const T& t );
    const T& fun2() const { return Fun1(); }
    void fun3( const T& t, int del = 0 ) { Fun12( t, del ); }
# endif  // T_NAMES

protected:

    void Fun7( int del = 0 );
    virtual TemplateClass<T,Alloc> *Fun8( const T& );
    virtual TemplateClass<T,Alloc> *Fun9( const T& t )
        {
        return Fun(t);
        }
    int Fun10( const T& t, int del = 0 )
        {
        return Fun2(Fun8(t),del);
        }

    TemplateClass<T,Alloc> Data1, Data2;
    int Data3;

private:

    virtual void Fun11( TemplateClass<T,Alloc> * ){};
    T&   Fun12();
    int  Fun13( TemplateClass<T,Alloc> *pred, int del = 0 );

};

#if defined( T_NAMES3 )
#define OC  OrdinaryClass
#endif // T_NAMES3

#endif  // TEST_H



