#include "stdio.h"

/* #define DO4K */

/*The following variable controls the transition date from the Julian
  calendar to the Gregorian calendar in our test case. A couple of
  values:
    2,299,161 = October 5/15, 1582, as in Rome
    2,361,222 = September 3/14, 1752, as in the U.K. and Colonies
  This value is simply passed as a parameter to the routines. */

#define TRANSITION 2299161L

extern long tojul();
extern void fromjul();

long j1,j2,trans;
long testcount;
short y1,y2,ytj,ytg;
unsigned char m1,m2,mtj,mtg,d1,d2,dtj,dtg,dow1,dow2;
static unsigned char mtbl[12]={31,28,31,30,31,30,31,31,30,31,30,31};
unsigned char skipichk;
unsigned char doall;

int main(argc,argv)
  int argc;
  char *argv[];
{
  long atol();
  m1=1; d1=1; y1= -4713; j1= -1; dow1=0;
  trans=TRANSITION;
  testcount=0;
  doall=0;
  if (argc>1)
    if (strcmp(argv[1],"all")==0) doall=1;
    else if (strcmp(argv[1],"some")!=0) {
	printf("Usage: TESTJUL [[some|all] TRANSITION]\n");
	printf("  where\n");
	printf("some|all is the string 'some' or 'all'\n");
	printf(
"  'some' results in uninteresting ranges being skipped (default)\n");
	printf(
"  'all' test all dates (takes about 11.5 times as long)\n");
	printf(
"TRANSITION is the (julian date) transition date, in decimal\n");
	printf("  2299161=Oct 5/15, 1582 (Rome, default)\n");
	printf("  2361222=Sep 3/14, 1752 (U.K.)\n");
	printf("  2423868=Mar 10/23, 1924 (Greece)\n");
	return 1;
      }
  if (argc>2) trans=atol(argv[2]);
  fromjul(trans,trans-1,&mtj,&dtj,&ytj);
  fromjul(trans-1,trans,&mtg,&dtg,&ytg);
nxtdt:
  testcount+=1;
  j2=tojul(trans,m1,d1,y1);
  dow2=dayofwk(j2);
  if (skipichk) skipichk=0;
  else {
      if (j1+1!=j2)
/* any output from this printf represents an error condition */
	printf("j1 %ld j2 %ld\n",j1,j2);
      if ((dow1==6 ? 0 : dow1+1)!=dow2)
/* any output from this printf represents an error condition */
	printf("dow1 %d dow2 %d\n",dow1,dow2);
    }
  j1=j2; dow1=dow2;
  fromjul(trans,j2,&m2,&d2,&y2);
  if ( m1!=m2 || d1!=d2 || y1!=y2 ) {
/* any output from this printf represents an error condition */
      printf("m1 %d d1 %d y1 %d m2 %d d2 %d y2 %d\n",m1,d1,y1,m2,d2,y2);
    }
  mtbl[1]=28;
  if (m1==2)
    if (((y1+(y1<0))&3)==0)
      if ( y1<ytj) mtbl[1]=29;
      else if ( (y1%100)!=0 || (y1%400)==0 )
#ifdef DO4K
	if ((y1%4000)!=0)
#endif
	  mtbl[1]=29;
  if (y1==ytj && d1==dtj && m1==mtj) {
      y1=ytg; d1=dtg; m1=mtg; goto nxtdt;
    }
  if (++d1<=mtbl[m1-1]) goto nxtdt;
  d1=1; if (++m1<=12) goto nxtdt;
  m1=1; if (y1<32767) {
      y1+=(y1== -1)+1;
      if (!doall) {
/*We mostly want to check at least one complete cycle of activity (100
  years during Julian, 400 years during Gregorian), transitions, and end
  points for the argument range. So we can (and usually do) skip some
  ranges in testing.*/
	  if (y1== -4400) { y1= -4050; skipichk=1; goto nxtdt; }
	  if (y1== -3950) { y1= -200; skipichk=1; goto nxtdt; }
	  if (y1== 200)   { y1= 1400; skipichk=1; goto nxtdt; }
	  if (y1==2100)   { y1= 3800; skipichk=1; goto nxtdt; }
	  if (y1==4200)   { y1= 7950; skipichk=1; goto nxtdt; }
	  if (y1==8050)   { y1=11950; skipichk=1; goto nxtdt; }
	  if (y1==12050)  { y1=15950; skipichk=1; goto nxtdt; }
	  if (y1==16050)  { y1=19950; skipichk=1; goto nxtdt; }
	  if (y1==20050)  { y1=23950; skipichk=1; goto nxtdt; }
	  if (y1==24050)  { y1=27950; skipichk=1; goto nxtdt; }
	  if (y1==28050)  { y1=31950; skipichk=1; goto nxtdt; }
	}
      goto nxtdt;
    }
  printf("%ld tests completed\n",testcount);
  return 0;
}
