#pragma warning (disable : 4001 4209 4100)
//
//  GO a sample CD-ROM application loader
//
//  (C) Copyright 1994 Microsoft Corp.  All rights reserved.
//
//  You have a royalty-free right to use, modify, reproduce and 
//  distribute the Sample Files (and/or any modified version) in 
//  any way you find useful, provided that you agree that 
//  Microsoft has no warranty obligations or liability for any 
//  Sample Application Files which are modified. 
//
#define STRICT 1
#define LPWSTR LPSTR

#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>
#include <mmsystem.h>
#include <digitalv.h>
#include <mciavi.h>
#include <memory.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <direct.h>
#include <limits.h>
#include "dibstuff.h"
#include "tblt.h"
#include "wintoon.h"
#include "toonapp.h"
#include "defs.h"
#include "dibasm.h"


typedef struct
{
	DWORD dwFrom;
	DWORD dwTo;
	RECT rcHot;
	RECT rcClip;
	POINT ptText;
	char text[32];
	int action;
	BOOL fExit;
	char command[512];
} HOTSPOT, FAR *LPHOTSPOT;

#define WM_TOONDRAW	(WM_USER + 1)
#define WM_TOONAPP_INIT	(WM_USER + 2)

#define C_HOTSPOT 20

static char *szScene = "Scene 1";

char szBuf[128];

int cHotspot;
int xDest, yDest;
int iHotspotCur = -1;

LOGFONT logfont = { 
	32, 0, 0, 0, 
	FW_HEAVY, 0, 0, 0, ANSI_CHARSET, 
	OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_ROMAN, 
	""
};
HFONT hfont;
DLGPROC dpAbout;
BOOL fPlaying;
char szMVB[_MAX_PATH];
HOTSPOT vHotspot[C_HOTSPOT];
BYTE iTransparent;

PDIB pdibStage;
PDIB pdibForeground;
PDIB pdibBackground;
WORD hmovie;
// VWR vwr;
HCURSOR hcursor;
BOOL fVerbose = FALSE;
HMENU hmenu = NULL;
int idPaint = -1;
int idList = -1;
int idSpeed = - 1;

BOOL DibFlip(PDIB pdib);
BOOL OnOpenFile(HWND hwnd, LPSTR szIn);
BOOL LoadBackground(HWND hwnd, HTOON htoon, LPSTR szFilename);

void SlamAVIOptions()
{
	WriteProfileString("MCIAVI", "UseAVIFile", "0");
	WriteProfileString("MCIAVI", "ZoomBy2", "0");
	WriteProfileString("MCIAVI", "SkipFrames", "1");
	WriteProfileString("MCIAVI", "DefaultVideo", "Window");
}

void CheckCommand(HMENU hmenu, int idOld, int idNew)
{
	if (idOld != -1)
		CheckMenuItem(hmenu, idOld, MF_BYCOMMAND | MF_UNCHECKED);
	if (idNew != -1)
		CheckMenuItem(hmenu, idNew, MF_BYCOMMAND | MF_CHECKED);
}

void ClipMovie(WORD hmovie, int left, int top, int right, int bottom)
{
	MCI_DGV_RECT_PARMS	mciRect;

	//
	// Note that the rc in MCI_DGV_RECT_PARMS is not a rect
	// it is a top left, width and height
	//
	mciRect.rc.left = left;
	mciRect.rc.top = top;
	mciRect.rc.right = right - left;
	mciRect.rc.bottom = bottom - top;

	//
	// Why check for errors about which you can do nothing :-)
	//
	mciSendCommand(hmovie, MCI_PUT, MCI_WAIT | MCI_DGV_PUT_DESTINATION | MCI_DGV_RECT, (DWORD)(LPMCI_DGV_RECT_PARMS)&mciRect);
	mciSendCommand(hmovie, MCI_PUT, MCI_WAIT | MCI_DGV_PUT_SOURCE | MCI_DGV_RECT, (DWORD)(LPMCI_DGV_RECT_PARMS)&mciRect);
}

void SafeYield()
{
	MSG msg;
	
	// Let's give Viewer a chance to bring itself up
			
	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		if (msg.message == WM_QUIT)
		{
			PostQuitMessage(msg.wParam);
			return;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}

int Dialog(HWND hwnd, UINT id, DLGPROC dlgproc)
{
	FARPROC dp;
	int ret = -1;
	
	if ((dp = MakeProcInstance((FARPROC)dlgproc, hInstance)) != NULL)
	{
		ret = DialogBox(hInstance, MAKEINTRESOURCE(id), hwnd, (DLGPROC)dp);
		FreeProcInstance(dp);
	}
	return ret;
}
		
BOOL FileOpenDialog(HWND hwnd, LPSTR sz, unsigned cb, LPSTR szFilter)
{
	OPENFILENAME ofn;
	
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.hInstance = NULL;
	ofn.lpstrFilter = szFilter;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = sz;
	ofn.nMaxFile = cb;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = NULL;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = NULL;
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;
	
	return GetOpenFileName(&ofn);
}               

BOOL OnStop(HWND hwnd)
{
	MCI_DGV_STOP_PARMS mciStop = { NULL };
	DWORD errCode;
	
	errCode = mciSendCommand(hmovie, MCI_STOP, 0, (DWORD)(LPMCI_DGV_STOP_PARMS)&mciStop);
	if (errCode)
	{
		mciGetErrorString(errCode, szBuf, sizeof(szBuf));
		MessageBox(hwnd, szBuf, "Couldn't play", MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
}

BOOL OnSetSpeed(HWND hwnd, UINT speed)
{
	MCI_DGV_SET_PARMS mciSet;
	DWORD errCode;
	
	mciSet.dwSpeed = speed * 10;
	errCode = mciSendCommand(hmovie, MCI_SET, MCI_DGV_SET_SPEED, (DWORD)(LPMCI_DGV_PLAY_PARMS)&mciSet);
	if (errCode)
	{
		mciGetErrorString(errCode, szBuf, sizeof(szBuf));
		MessageBox(hwnd, szBuf, "Couldn't set speed", MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
}

//
// Abitrarily uses all the hot spot rects as a test case
// In real life you should use the rects from a representative frame
//
#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

void OnProfile(HWND hwnd)
{
	int iPaint, iPaintBest;
	int iNumSamples;
	DWORD timePaint, timePaintBest = 0;
	int iHotspot = 2;
	int i;
	HTOON htoon = ToonFromWindow(hwnd);
	static char buf[2048];
	int iBuf = 0;
	HDC hdc = GetDC(hwnd);
	RECT rc;

	GetClientRect(hwnd, &rc);

	iPaintBest = 0;
	timePaintBest = LONG_MAX;

	FillRect(hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
	ToonSetPaintMethod(htoon, PAINT_NONE+1);
	timePaint = timeGetTime();
	for (i = 0 ; i < 10; i++)
	{
		for (iHotspot = 0 ; iHotspot < cHotspot ; iHotspot++)
		{
			ToonMarkRect(htoon, &vHotspot[iHotspot].rcHot);
		}
		ToonPaintRects(htoon);
	}
	timePaint = max(1, timeGetTime() - timePaint); 	// prevent possible division by 0
	iNumSamples = (int)max(10, 50000L/timePaint);  	// Get # of samples to run for about 5 seconds
											 		// 10 samples minimum

	for (iPaint = PAINT_NONE + 1 ; iPaint < PAINT_ALL ; iPaint++)
	{
		FillRect(hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
		ToonSetPaintMethod(htoon, iPaint);
		timePaint = timeGetTime();
		for (i = 0 ; i < iNumSamples ; i++)
		{
			for (iHotspot = 0 ; iHotspot < cHotspot ; iHotspot++)
			{
				ToonMarkRect(htoon, &vHotspot[iHotspot].rcHot);
			}
			ToonPaintRects(htoon);
		}
		timePaint = timeGetTime() - timePaint;

		iBuf += wsprintf(&buf[iBuf], "Method %d: %lu\r\n", iPaint, timePaint);
		if (timePaint < timePaintBest)
		{
			iPaintBest = iPaint;
			timePaintBest = timePaint;
		}
	}
	wsprintf(&buf[iBuf], "\r\nSet paint method to %d ?", iPaintBest);
	if (MessageBox(hwnd, buf, "Profile results", MB_YESNO) == IDYES)
	{
		CheckCommand(hmenu, idPaint, ID_PAINT_BASE + iPaintBest);
		idPaint = ID_PAINT_BASE + iPaintBest;
	}
	ToonSetPaintMethod(htoon, idPaint - ID_PAINT_BASE);
	ToonMarkRect(htoon, NULL);
	ToonPaintRects(htoon);
	ReleaseDC(hwnd, hdc);
}


unsigned long ATS_DibHeight(PDIB pdib)
{
	long retVal = pdib->biHeight;
  return  (retVal >0L	? (unsigned long) retVal : (unsigned long)-retVal );
}

unsigned short ATS_DibPitch(PDIB pdib)
{
	unsigned short retVal;// = (unsigned short) (pdib->biHeight);
	unsigned short widthBytes;

	widthBytes = (unsigned short)pdib->biWidth *
					(unsigned short)pdib->biBitCount;
	retVal = ((widthBytes+31)&(~31))/8;

  return  retVal;
}

unsigned long ATS_DibSizeImage(PDIB pdib)
{
	unsigned long retVal = pdib->biSizeImage;

	if (retVal == 0L)
		retVal = (unsigned long)DibPitch(pdib) * (unsigned long)DibHeight(pdib);

  return  retVal;
}


void BuildStage(int iHotspot)
{
	int i;
	HOTSPOT *pHotspot;
	unsigned long imageSize;

	imageSize = DibSizeImage(pdibStage);
	CopyBytes((LPBYTE)DibPtr(pdibStage), (LPBYTE)DibPtr(pdibBackground), imageSize);

	for (i = 0 , pHotspot = &vHotspot[0] ; i < cHotspot ; i++ , pHotspot++)
	{
		if (i != iHotspot)
		{
			DibTransparentBlt((PDIB)pdibStage, (LPBYTE)DibPtr(pdibStage), pHotspot->rcHot.left, pHotspot->rcHot.top,
				(PDIB)pdibForeground, (LPBYTE)DibPtr(pdibForeground), pHotspot->rcHot.left, pHotspot->rcHot.top, 
				pHotspot->rcHot.right - pHotspot->rcHot.left, pHotspot->rcHot.bottom - pHotspot->rcHot.top, iTransparent);
		}
	}
}

void ShowTip(HWND hwnd, int iHotspot)
{
	static RECT rcTip;
	HTOON htoon = ToonFromWindow(hwnd);
	
	ToonRestoreBackground(htoon);

	if (IsRectEmpty(&rcTip) == FALSE)
	{
		ToonMarkRect(htoon, &rcTip);
	}

	SetRect(&rcTip, 0, 0, 0, 0);

	if (iHotspot != -1)
	{
		UINT cb = lstrlen(vHotspot[iHotspot].text);
		HDC hdc = ToonDC(htoon);
		int mode = SetBkMode(hdc, TRANSPARENT);
		COLORREF color;
		HFONT hfontOld = (HFONT)SelectObject(hdc, hfont);
		DWORD dwSize = 	GetTextExtent(hdc, vHotspot[iHotspot].text, cb);
		
		rcTip.left = vHotspot[iHotspot].ptText.x - 2;
		rcTip.top = vHotspot[iHotspot].ptText.y - HIWORD(dwSize) - 2;
		rcTip.right = rcTip.left + LOWORD(dwSize);
		rcTip.bottom = rcTip.top + HIWORD(dwSize);

		if (rcTip.left < 0)
		{
			OffsetRect(&rcTip, - rcTip.left, 0);
		}
		if (rcTip.top < 0)
		{
			OffsetRect(&rcTip, 0, - rcTip.top);
		}
		if ((UINT)rcTip.right > DibWidth(pdibBackground))
		{
			OffsetRect(&rcTip, DibWidth(pdibBackground) - rcTip.right, 0);
		}
		if ((UINT)rcTip.bottom > DibHeight(pdibBackground))
		{
			OffsetRect(&rcTip, 0, DibHeight(pdibBackground) - rcTip.bottom);
		}

		ToonMarkRect(htoon, &rcTip);

		color = SetTextColor(hdc, RGB(0, 0, 0));
		TextOut(hdc, rcTip.left + 2, rcTip.top + 2, vHotspot[iHotspot].text, cb);

		SetTextColor(hdc, RGB(255, 255, 255));
		TextOut(hdc, rcTip.left, rcTip.top, vHotspot[iHotspot].text, cb);
		
		SetBkMode(hdc, mode);
		SetTextColor(hdc, color);
		SelectObject(hdc, hfontOld);
		
	}
	ToonPaintRects(htoon);
}	

//
// Play the whole movie
//
BOOL OnPlay(HWND hwnd)
{
	MCI_DGV_PLAY_PARMS      mciPlay;
	DWORD errCode;
	HTOON htoon = ToonFromWindow(hwnd);

	if (hmovie == NULL)
		return FALSE;
	
	mciPlay.dwFrom = 0;
	mciPlay.dwCallback = MAKELONG(hwnd, 0);

	CopyBytes((LPBYTE)DibPtr(pdibStage), (LPBYTE)DibPtr(pdibBackground), DibSizeImage(pdibStage));

	ToonRestoreBackground(htoon);
	
	errCode = mciSendCommand(hmovie, MCI_PLAY, MCI_NOTIFY | MCI_FROM | MCI_MCIAVI_PLAY_WINDOW, (DWORD)(LPMCI_DGV_PLAY_PARMS)&mciPlay);

	if (errCode)
	{
		mciGetErrorString(errCode, szBuf, sizeof(szBuf));
		MessageBox(hwnd, szBuf, "Couldn't play", MB_ICONEXCLAMATION);
		return FALSE;
	}

	hcursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
	fPlaying = TRUE;

	return TRUE;
}

BOOL OnHotspot(HWND hwnd, int iHotspot)
{
	MCI_DGV_PLAY_PARMS	mciPlay;
	DWORD errCode = 0;
//	HTOON htoon = ToonFromWindow(hwnd);

	if ((iHotspot < 0)
	||  (iHotspot >= cHotspot))
		return FALSE;

	BuildStage(iHotspot);
	
	if (IsRectEmpty(&vHotspot[iHotspot].rcClip) == FALSE)
	{
		ClipMovie(hmovie, vHotspot[iHotspot].rcClip.left, 
				vHotspot[iHotspot].rcClip.top, 
				vHotspot[iHotspot].rcClip.right, 
				vHotspot[iHotspot].rcClip.bottom);
	}

	mciPlay.dwFrom = vHotspot[iHotspot].dwFrom;
	mciPlay.dwTo = vHotspot[iHotspot].dwTo;
        mciPlay.dwCallback = MAKELONG(hwnd, 0);

	errCode = mciSendCommand(hmovie, MCI_PLAY, MCI_NOTIFY | MCI_TO | MCI_FROM, (DWORD)(LPMCI_DGV_PLAY_PARMS)&mciPlay);
	if (errCode)
		goto error;		

	hcursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
	fPlaying = TRUE;
	return TRUE;
error:
	mciGetErrorString(errCode, szBuf, sizeof(szBuf));
	MessageBox(hwnd, szBuf, "MCI Error", MB_ICONEXCLAMATION);
	return FALSE;
}

OnMCINotify(HWND hwnd, UINT /*message*/, WORD /*wDeviceID*/)
{
	HTOON htoon = ToonFromWindow(hwnd);

	ClipMovie(hmovie, 0, 0, DibWidth(pdibBackground), DibHeight(pdibBackground));
	
	fPlaying = FALSE;
	BuildStage(-1);
	SetCursor(hcursor);
	ToonRestoreBackground(htoon);
	ToonMarkRect(htoon, NULL);
	InvalidateRect(hwnd, NULL, FALSE);

	if ((iHotspotCur >= 0) && (iHotspotCur < cHotspot))
	{
		switch (vHotspot[iHotspotCur].action)
		{
		case 0:
			break;
		case 1:
			iHotspotCur = atoi(vHotspot[iHotspotCur].command);
			OnHotspot(hwnd, iHotspotCur);
			break;
		case 2:
			DestroyWindow(hwnd);
			break;
		case 3:
			OnOpenFile(hwnd, vHotspot[iHotspotCur].command);
			break;
		case 4:
		//	if (vwr && VwrCommand(vwr, szMVB, vHotspot[iHotspotCur].command, cmdoptNONE))
		//	{
		//		// Move behind the viewer window once it's ready
		//		SetWindowPos(hwnd, HwndFromVwr(vwr), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		//	}
		//	Do nothing
			break;
		case 5:
			WinExec(vHotspot[iHotspotCur].command, SW_NORMAL);
			break;
		case 6:
			MessageBox(hwnd, vHotspot[iHotspotCur].command, szAppName, MB_OK);
			break;
		case 7:
			LoadBackground(hwnd, ToonFromWindow(hwnd), vHotspot[iHotspotCur].command);
			break;
		}
		if (vHotspot[iHotspotCur].fExit)
			DestroyWindow(hwnd);
	}

	return TRUE;
}
	
BOOL OnCue(HWND hwnd)
{
	DWORD errCode = 0;
	MCI_DGV_CUE_PARMS mciCue;
	
	mciCue.dwCallback = NULL;
	mciCue.dwTo = 0;
	
	errCode = mciSendCommand(hmovie, MCI_CUE, MCI_TO | MCI_DGV_CUE_OUTPUT, (DWORD)(LPMCI_DGV_CUE_PARMS)&mciCue);
	if (errCode)
	{
		mciGetErrorString(errCode, szBuf, sizeof(szBuf));
		MessageBox(hwnd, szBuf, "Couldn't cue", MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
}

void OnCloseFile(HWND hwnd)
{
	MCI_GENERIC_PARMS mciGeneric;

	// if (vwr)
	// {
	//	VwrQuit(vwr);
	//	vwr = NULL;
	// }
	if (pdibBackground)
	{
		DibFree(pdibBackground);
		pdibBackground = NULL;
	}

	if (pdibForeground)
	{
		DibFree(pdibForeground);
		pdibForeground = NULL;
	}

	if (pdibStage)
	{
		DibFree(pdibStage);
		pdibStage = NULL;
	}

	if (hmovie)
	{
		mciSendCommand(hmovie, MCI_CLOSE, MCI_WAIT, (DWORD)(LPMCI_GENERIC_PARMS)&mciGeneric);
		hmovie = NULL;
	}

	cHotspot = 0;

	ToonSetBackground(ToonFromWindow(hwnd), NULL, NULL);
}

BOOL LoadBackground(HWND hwnd, HTOON htoon, LPSTR szFilename)
{
	PDIB pdibBg, pdibSt;
        int x, y, cx, cy;
        
	if ((pdibBg = DibOpenFile(szFilename)) != NULL)
	{
		if (ToonIsTopDown(htoon) != (pdibBg->biHeight < 0))
			DibFlip(pdibBg);
		if ((pdibSt = DibCopy(pdibBg)) != NULL)
		{
			pdibBackground = pdibBg;
			pdibStage = pdibSt;
			
			BuildStage(-1);

			ToonSetBackground(htoon, pdibStage, (LPBYTE)DibPtr(pdibStage));
			ToonSetColors(htoon, DibColors(pdibStage));
			ToonRestoreBackground(htoon);

			x = (GetSystemMetrics(SM_CXSCREEN) - DibWidth(pdibBg)) / 2;
			if (x < 0)
				x = 0;
			y = (GetSystemMetrics(SM_CYSCREEN) - DibHeight(pdibBg)) / 2;
			if (y < 0)
				y = 0;
			cx = DibWidth(pdibBg);
			cy = DibHeight(pdibBg);
			MoveWindow(hwnd, x, y, cx, cy, FALSE);

			InvalidateRect(hwnd, NULL, FALSE);
			return TRUE;
		}
	}
	return FALSE;
}

POINT GetPrivateProfilePoint(LPSTR szSection, LPSTR szKey, POINT ptDefault, LPSTR szFile)
{
	char buf[16];
	char *p;
	POINT pt;
	
	if (GetPrivateProfileString(szSection, szKey, "", buf, sizeof(buf), szFile) == 0)
		return ptDefault;
	if ((p = strtok(buf, " ")) == NULL)
		return ptDefault;
	pt.x = atoi(p);
	
	if ((p = strtok(NULL, " ")) == NULL)
		return ptDefault;
	pt.y = atoi(p);

	return pt;
}

BOOL GetPrivateProfileRect(LPSTR szSection, LPSTR szKey, LPRECT pRect, LPSTR szFile)
{
	char buf[32];
	char *p;
	
	if (GetPrivateProfileString(szSection, szKey, "", buf, sizeof(buf), szFile) == 0)
		return FALSE;
		
	if ((p = strtok(buf, " ")) == NULL)
		return FALSE;
	pRect->left = atoi(p);
	if ((p = strtok(NULL, " ")) == NULL)
		return FALSE;
	pRect->top = atoi(p);
	if ((p = strtok(NULL, " ")) == NULL)
		return FALSE;
	pRect->right = atoi(p);
	if ((p = strtok(NULL, " ")) == NULL)
		return FALSE;
	pRect->bottom = atoi(p);
		
	return TRUE;
}

void StartViewer(HWND hwnd, LPSTR /*szMVB*/, LPSTR /*szCommand*/)
{

	// Make sure we're on top so that Viewer doesn't bug us
	SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);

	// if ((vwr = VwrCommand(NULL, szMVB, szCommand, cmdoptHIDE)) != NULL)
	// {
	// 	SafeYield();
		
	//	SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	//	SetWindowPos(HwndFromVwr(vwr), hwnd, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

		// If for some reason (smirk), viewer took our activation, take it back
	//	if (GetActiveWindow() != hwnd)
	//	{
	//		SetActiveWindow(hwnd);
	//	}
	// }
	// else
	// {
	//	SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	// }
}
			
BOOL OnOpenFile(HWND hwnd, LPSTR szIn)
{
	HTOON htoon = ToonFromWindow(hwnd);
	HOTSPOT *pHotspot;
	char szFilename[_MAX_PATH];
	char szFull[_MAX_PATH];
        char szDir[_MAX_DIR];
	char buf[512];
	        
	OnCloseFile(hwnd);

	if (szIn == NULL)
	{
		szFilename[0] = 0;
		if (FileOpenDialog(hwnd, szFilename, sizeof(szFilename), "Cartoons\0*.ctn\0All Files\0*.*\0") == FALSE)
			return FALSE;
	}
	else
	{
		lstrcpy(szFilename, szIn);
	}

	_fullpath(szFull, szFilename, sizeof(szFull));

	if (access(szFull, 0))
	{
		goto error;
	}

	hcursor = SetCursor(LoadCursor(NULL, IDC_WAIT));

	_splitpath(szFull, NULL, szDir, NULL, NULL);
	lstrcat(szDir, ".");
	if (chdir(szDir))
		goto error;

	for (cHotspot = 0 , pHotspot = &vHotspot[0] ; cHotspot < C_HOTSPOT ; cHotspot++ , pHotspot++)
	{

		wsprintf(buf, "Hotspot %d", cHotspot);
		if (GetPrivateProfileInt(buf, "from", -1, szFull) == 0xFFFF)
			break;
		pHotspot->dwFrom = GetPrivateProfileInt(buf, "from", -1, szFull);
		pHotspot->dwTo = GetPrivateProfileInt(buf, "to", -1, szFull);

		GetPrivateProfileRect(buf, "hot", &pHotspot->rcHot, szFull);
		GetPrivateProfileRect(buf, "clip", &pHotspot->rcClip, szFull);

		pHotspot->ptText.x = pHotspot->rcHot.left;
		pHotspot->ptText.y = pHotspot->rcHot.top;
		pHotspot->ptText = GetPrivateProfilePoint(buf, "ptText", pHotspot->ptText, szFull);
		GetPrivateProfileString(buf, "text", "", pHotspot->text, sizeof(pHotspot->text), szFull);
		GetPrivateProfileString(buf, "command", "", pHotspot->command, sizeof(pHotspot->command), szFull);
		pHotspot->fExit = GetPrivateProfileInt(buf, "exit", 0, szFull);
		pHotspot->action = GetPrivateProfileInt(buf, "action", 0, szFull);
	}

	iTransparent = (BYTE)GetPrivateProfileInt(szScene, "Transparent", 0, szFull);
	
	GetPrivateProfileString(szScene, "Foreground", "", szFilename, sizeof(szFilename), szFull);
	if ((pdibForeground = DibOpenFile(szFilename)) == NULL)
		goto error;

	//
	// Strictly speaking, we don't actually have to flip the
	// foreground since it gets Blt'd and not copied but hey,
	// it's cheap
	//
	if (ToonIsTopDown(htoon) != (pdibForeground->biHeight < 0))
		DibFlip(pdibForeground);

	GetPrivateProfileString(szScene, "Background", "", szFilename, sizeof(szFilename), szFull);
	if (LoadBackground(hwnd, htoon, szFilename) == FALSE)
		goto error;

	if ((DibWidth(pdibForeground) != DibWidth(pdibBackground))
	||  (DibHeight(pdibForeground) != DibHeight(pdibBackground)))
		goto error;
	GetPrivateProfileString(szScene, "Movie", "", szFilename, sizeof(szFilename), szFull);

	SlamAVIOptions();

	if ((hmovie = ToonOpenMovie(htoon, szFilename, iTransparent)) == NULL)
	{
		goto error;
	}

	if (ToonSetPaintList(htoon, LIST_NORMAL))
	{
		CheckCommand(hmenu, idList, ID_LIST_NORMAL);
		idList = ID_LIST_NORMAL;
	}
	if (ToonSetPaintMethod(htoon, PAINT_INVALIDATE_RECT))
	{
		idPaint = ID_PAINT_INVALIDATE_RECT;
		CheckCommand(hmenu, idPaint, ID_PAINT_INVALIDATE_RECT);
	}
	if (OnSetSpeed(hwnd, ID_SPEED_NORMAL - ID_SPEED_BASE))
	{
		idSpeed = ID_SPEED_NORMAL;
		CheckCommand(hmenu, idSpeed, ID_SPEED_NORMAL);
	}


	if (GetPrivateProfileString(szScene, "MVB", "", szMVB, sizeof(szMVB), szFull)
	&&  GetPrivateProfileString(szScene, "command", "", buf, sizeof(buf), szFull))
	{
		StartViewer(hwnd, szMVB, buf);
	}
	
	SetCursor(hcursor);
	
	// Ok everything is loaded, let's play the intro
	if ((iHotspotCur = GetPrivateProfileInt(szScene, "intro", -1, szFull)) != -1)
		OnHotspot(hwnd, iHotspotCur);

	return TRUE;

error:
	OnCloseFile(hwnd);
	SetCursor(hcursor);
	return FALSE;
}

void FreeSystemResources(HWND hwnd)
{
	HTOON htoon;

	if ((htoon = ToonFromWindow(hwnd)) != NULL)
		ToonDestroy(htoon);

	if (dpAbout)
	{
		FreeProcInstance((FARPROC)dpAbout);
		dpAbout = NULL;
	}

	if (hfont)
	{
		DeleteObject(hfont);
		hfont = NULL;
	}

	if (hmenu)
	{
		DestroyMenu(hmenu);
		hmenu = NULL;
	}
}

BOOL OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreate)
{
	RECT rc;
	HTOON htoon;

	if ((dpAbout = (DLGPROC)MakeProcInstance((FARPROC)AboutDP, hInstance)) == NULL)
		goto error;


	lpCreate->x = (GetSystemMetrics(SM_CXSCREEN) - 640) / 2;
	lpCreate->y = (GetSystemMetrics(SM_CYSCREEN) - 480) / 2;
	lpCreate->cx = 640;
	lpCreate->cy = 480;

	if ((hmenu = LoadMenu(hInstance, MAKEINTRESOURCE(ID_APP))) == NULL)
		goto error;
	hmenu = GetSubMenu(hmenu, 0);

	if ((ToonVersion() != WINTOON_VERSION)
	&&  (MessageBox(hwnd, "Incorrect version of WinToon\nContinue anyway?", szAppName, MB_YESNO) != IDYES))
	{
		return FALSE;
	}
	idPaint = ID_PAINT_DEFAULT;
	idList =  ID_LIST_NORMAL;
	idSpeed = ID_SPEED_NORMAL;

	if ((hfont = CreateFontIndirect(&logfont)) == NULL)
		goto error;
	if ((htoon = ToonCreate(hwnd, lpCreate->cx, lpCreate->cy, 0)) == NULL)
		goto error;
	ToonSetMessage(htoon, WM_TOONDRAW);

	SetRect(&rc, 0, 0, lpCreate->cx, lpCreate->cy);
	FillRect(ToonDC(htoon), &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
	
	if ((lpCreate->lpCreateParams != NULL)
	&&  (*((LPSTR)(lpCreate->lpCreateParams)) != 0))
	{
		if (OnOpenFile(hwnd, (LPSTR)(lpCreate->lpCreateParams)) == FALSE)
		{
			MessageBox(hwnd, (LPSTR)(lpCreate->lpCreateParams), "Couldn't open cartoon", MB_OK);
		}
	}
	else
	{
		if (OnOpenFile(hwnd, "toonapp.ctn") == FALSE)
		{
			if (OnOpenFile(hwnd, NULL) == FALSE)
				goto error;
		}
	}

	return TRUE;
error:
	FreeSystemResources(hwnd);
	return FALSE;
}

void OnDestroy(HWND hwnd)
{
	OnCloseFile(hwnd);
	FreeSystemResources(hwnd);
	PostQuitMessage(0);
}

void OnCommand(HWND hwnd, int id, HWND /*hwndCtl*/, UINT /*codeNotify*/)
{
	HTOON htoon = ToonFromWindow(hwnd);

	switch (id)
	{
	case ID_SPEED_ZERO:
	case ID_SPEED_HALF:
	case ID_SPEED_NORMAL:
	case ID_SPEED_DOUBLE:
		if (OnSetSpeed(hwnd, (id - ID_SPEED_BASE)))
		{
			CheckCommand(hmenu, idSpeed, id);
			idSpeed = id;
		}
		break;
	case ID_LIST_NORMAL:
	case ID_LIST_FAST:
	case ID_LIST_SLOW:
		if (ToonSetPaintList(htoon, id - ID_LIST_BASE))
		{
			CheckCommand(hmenu, idList, id);
			idList = id;
		}
		break;
	case ID_PAINT_NONE:
	case ID_PAINT_ALL:
	case ID_PAINT_MULTIPLE_BLT:
	case ID_PAINT_INVALIDATE_RECT:
	case ID_PAINT_CLIP_REGION:
		if (ToonSetPaintMethod(htoon, id - ID_PAINT_BASE))
		{
			CheckCommand(hmenu, idPaint, id);
			idPaint = id;
		}
		break;
	case ID_CUE:
		OnCue(hwnd);
		break;
	case ID_PROFILE:
		OnProfile(hwnd);
		break;
	case ID_PLAY:
		OnPlay(hwnd);
		break;
	case ID_STOP:
		OnStop(hwnd);
		break;
	case ID_VERBOSE:
		fVerbose = !fVerbose;
		InvalidateRect(hwnd, 0, FALSE);
		break;
	case ID_ABOUT:
		Dialog(hwnd, ID_ABOUT, dpAbout);
		break;
	case ID_OPEN:
		if (OnOpenFile(hwnd, NULL))
			InvalidateRect(hwnd, 0, FALSE);
		break;
	case ID_EXIT:
		DestroyWindow(hwnd);
	}
}

#ifdef _DEBUG
void OnToonDraw(HWND hwnd, HTOON htoon, LONG lFrame)
{
	HDC hdc = ToonDC(htoon);
	static char sz[128];
	RECT rc;
	UINT cb;
	SIZE size;

	wsprintf(sz, "OnToonDraw hwnd: %04x lFrame: %ld\n", hwnd, lFrame);
	OutputDebugString(sz);

	cb = wsprintf(sz, "Underneath frame %ld", lFrame);
	TextOut(hdc, 100, 100, sz, cb);
	GetTextExtentPoint(hdc, sz, cb, &size);
	SetRect(&rc, 100, 100, 100 + size.cx, 100 + size.cy);
	ToonMarkRect(htoon, &rc);
	
	ToonDrawCurrentFrame(htoon);

	cb = wsprintf(sz, "Above frame %ld", lFrame);
	TextOut(hdc, 400, 400, sz, cb);
	GetTextExtentPoint(hdc, sz, cb, &size);
	SetRect(&rc, 400, 400, 400 + size.cx, 400 + size.cy);
	ToonMarkRect(htoon, &rc);

}
#endif

int HotspotFind(int x, int y)
{
	POINT pt;
	int i;

	pt.x = x;
	pt.y = y;

	for (i = 0 ; i < cHotspot ; i++)
	{
		if (PtInRect(&vHotspot[i].rcHot, pt))
		{
			return i;
		}
	}
	return -1;
}
	
void OnLButtonDown(HWND hwnd, BOOL /*fDoubleClick*/, int x, int y, UINT /*keyFlags*/)
{
	if (fPlaying)
	{
		MCI_DGV_STOP_PARMS mciStop;
		
		mciSendCommand(hmovie, MCI_STOP, MCI_WAIT, (DWORD)(LPMCI_DGV_STOP_PARMS)&mciStop);
	}
	else if ((iHotspotCur = HotspotFind(x, y)) != -1)
	{
		ShowTip(hwnd, -1);
		OnHotspot(hwnd, iHotspotCur);
	}
}

void OnMouseMove(HWND hwnd, int x, int y, UINT /*keyFlags*/)
{
	int iHotspot;
	
	if (fPlaying)
		return;
	
	iHotspot = HotspotFind(x, y);
	if (iHotspot != iHotspotCur)
	{
		iHotspotCur = iHotspot;
		ShowTip(hwnd, iHotspotCur);
	}

}

/* void Cls_OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags); */
void OnRButtonDown(HWND hwnd, BOOL /*fDoubleClick*/, int x, int y, UINT /*keyFlags*/)
{
	POINT pt;
	
	if (fPlaying)
		return;
	pt.x = x;
	pt.y = y;
	ClientToScreen(hwnd, &pt);
	TrackPopupMenu(hmenu, TPM_RIGHTBUTTON | TPM_CENTERALIGN, pt.x, pt.y, 0, hwnd, NULL);
}

BOOL OnPaint(HWND hwnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HTOON htoon = ToonFromWindow(hwnd);
	
	hdc = BeginPaint(hwnd, &ps);
	ToonPaintDC(htoon, hdc);
	EndPaint(hwnd, &ps);
	return TRUE;
}

/* void Cls_OnActivate(HWND hwnd, UINT state, HWND hwndActDeact, BOOL fMinimized); */
void OnActivate(HWND hwnd, UINT state, HWND /*hwndActDeact*/, BOOL /*fMinimized*/)
{
	if (state != WA_INACTIVE)
	{
		SetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
	}
}

LRESULT CALLBACK MainWP(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	switch (message)
	{
#ifdef _DEBUG
	case WM_TOONDRAW:
		OnToonDraw(hwnd, (HTOON)wparam, lparam);
		return TRUE;
#endif
	case MM_MCINOTIFY:
		OnMCINotify(hwnd, wparam, LOWORD(lparam));
		return TRUE;
	case WM_RBUTTONDOWN:
		return HANDLE_WM_LBUTTONDOWN(hwnd, wparam, lparam, OnRButtonDown);
	case WM_ACTIVATE:
		return HANDLE_WM_ACTIVATE(hwnd, wparam, lparam, OnActivate);
	case WM_LBUTTONDOWN:
		return HANDLE_WM_LBUTTONDOWN(hwnd, wparam, lparam, OnLButtonDown);
	case WM_MOUSEMOVE:
		return HANDLE_WM_MOUSEMOVE(hwnd, wparam, lparam, OnMouseMove);
	case WM_CREATE:
		return HANDLE_WM_CREATE(hwnd, wparam, lparam, OnCreate);
	case WM_DESTROY:
		return HANDLE_WM_DESTROY(hwnd, wparam, lparam, OnDestroy);
//		break;
	case WM_PALETTECHANGED:
		return HANDLE_WM_PALETTECHANGED(hwnd, wparam, lparam, ToonOnPaletteChanged);
	case WM_QUERYNEWPALETTE:
		return HANDLE_WM_QUERYNEWPALETTE(hwnd, wparam, lparam, ToonOnQueryNewPalette);
	case WM_PAINT:
		return HANDLE_WM_PAINT(hwnd, wparam, lparam, OnPaint);
	case WM_COMMAND:
		return HANDLE_WM_COMMAND(hwnd, wparam, lparam, OnCommand);
	default:
		return ToonDefWindowProc(hwnd, message, wparam, lparam);
	}

//   return NULL;
}

BOOL CALLBACK AboutDP(HWND hdlg, UINT message, WPARAM /*wparam*/, LPARAM /*lparam*/)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;
	case WM_LBUTTONDOWN:
	case WM_COMMAND:
		EndDialog(hdlg, TRUE);
		return TRUE;
	default:
		return FALSE;
	}
}

BOOL DibFlip(PDIB pdib)
{
	UINT cLine = DibHeight(pdib);
	UINT cFlip = cLine / 2;
	long cbLine = DibWidthBytes(pdib);
	UINT i;
	HPBYTE lpTop, lpBottom, lpTemp;
	static BYTE temp[640];
	
	//
	// Handle stupid cases
	//
	if (cLine < 2)
	{
		pdib->biHeight = -pdib->biHeight;
		return TRUE;
	}

	if (cbLine > 640)
	{
		if ((lpTemp = (HPBYTE)GlobalAllocPtr(GHND, cbLine)) == NULL)
			return FALSE;
	}
	else
	{
		lpTemp = &temp[0];
	}

	lpTop = (HPBYTE)DibPtr(pdib);
	lpBottom = lpTop + (cLine - 1) * cbLine;
	for (i = 0 ; i < cFlip ; i++)
	{
		if (lpBottom < lpTop)
			return FALSE;
		hmemcpy(lpTemp, lpTop, cbLine);
		hmemcpy(lpTop, lpBottom, cbLine);
		hmemcpy(lpBottom, lpTemp, cbLine);

		lpTop += cbLine;
		lpBottom -= cbLine;
	}
	
	if (lpTemp != &temp[0])
		GlobalFreePtr(lpTemp);
	pdib->biHeight = -pdib->biHeight;
	return TRUE;
}
